function varargout = Menu_CBR(varargin)
%Pantalla pensada per configurar, visualitzar i trevallar amb els objectes
%de classe CBR.
%
%Per invocar directament des de consola aquesta pantalla nomes cal
%invocar-ne la funcio sense cap parametre extra (sempre que hi hagi
%objectes CBR al workspace):
%Menu_CBR();
%
%Tamb es pot invocar fent doble click sobre un objecte CBR del workspace.

gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @Menu_CBR_OpeningFcn, ...
    'gui_OutputFcn',  @Menu_CBR_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

function Menu_CBR_OpeningFcn(hObject, ~, handles, varargin)
%funci que s'invoca en crear la finestra a varargin ens arriven el
%possibles parametres extres d'invocaci de Pantalla. No els
%utilitzarem per res. hObject i handles els modificarem.

handles.output = hObject;
handles=menu(handles);
guidata(hObject, handles); %guardem els canvis

%busquem objectes dades
x=evalin('base','whos();');
list=[];
list2=[];
for i=1:length(x)
    if strcmp(x(i).class,'DATA') ~=0
        list=[list; {x(i).name}];
    end
    
    if strcmp(x(i).class,'CBR') ~=0
        list2=[list2; {x(i).name}];
    end
end
if isempty(list)
    list={'No DATA object in workspace'};
end
set(handles.popupmenu10,'String',list);

%busquem objectes CBR
%ja els tenim a list2!
if isempty(list2)
    list2={'No DATA object in workspace'};
end
set(handles.popupmenu1,'String',list2);

set(handles.edit5,'Visible','off');
set(handles.edit6,'Visible','off');
set(handles.text15,'Visible','off');
set(handles.text16,'Visible','off');

%deshabilitem el que no es pot tocar fins a selecionar el CBR
set(handles.pushbutton7,'enable','off');
set(handles.pushbutton6,'enable','off');
set(handles.pushbutton5,'enable','off');
set(handles.pushbutton4,'enable','off');
set(handles.pushbutton3,'enable','off');
set(handles.pushbutton2,'enable','off');
set(handles.pushbutton10,'enable','off');
set(handles.pushbutton11,'enable','off');

set(handles.popupmenu10,'enable','off');
set(handles.popupmenu4,'enable','off');
set(handles.popupmenu3,'enable','off');
set(handles.popupmenu2,'enable','off');

set(handles.edit8,'enable','off');
set(handles.edit2,'enable','off');
axes(handles.axes1);
cla(gcf);
set(handles.axes1,'Visible','off');
datacursormode off

if ~isempty(varargin) %si ens passen parametres interpretem que es l'element que volen seleccionar!!
    ind =max(strcmp(list2,varargin{1})' .* (1:length(list2)));
    if(ind ~= 0)
        set(handles.popupmenu1,'value', ind); %posem l'element que ens passen per parametre com a seleccionat
        popupmenu1_Callback(-1,-1,handles);
    end
else
    %si no nomes mostrem els parametres de l'actual
    popupmenu1_Callback(hObject,-1,handles);
    
end
%Posem be els textos de veins
popupmenu4_Callback(-1, -1, handles)

function varargout = Menu_CBR_OutputFcn(~, ~, handles)
varargout{1} = handles.output;

function pushbutton2_Callback(~, ~, handles)
% Retrieve
try
    %recuperem les dades
    variable=get(handles.popupmenu1,'String');
    mcbr=variable{get(handles.popupmenu1,'Value')};

    
    variable=get(handles.popupmenu10,'String');
    dade=variable{get(handles.popupmenu10,'Value')};

    
    if evalin('base',[mcbr '.isOptimized();']) == 0
        dc=get(handles.popupmenu4,'Value');
        
        extra='';
        switch dc
            case 4
                %distancies dobles
                vk=[ '[' get(handles.edit2,'String') ' ' get(handles.edit8,'String')  ']' ];
            case 5
                %distancies dobles
                vk=[ '[' get(handles.edit2,'String') ' ' get(handles.edit8,'String')  ']' ];
            case 6
                %distancies dobles
                vk=[ '[' get(handles.edit2,'String') ' ' get(handles.edit8,'String')  ']' ];
                
            case 17
                %distancia simple mes parametre extra
                vk=[ '[' get(handles.edit2,'String') ' ' get(handles.edit2,'String')  ']' ];
                extra =[', ' get(handles.edit8,'String') ];
                
            case 18
                %distancia simple mes parametre extra
                vk=[ '[' get(handles.edit2,'String') ' ' get(handles.edit2,'String')  ']' ];
                extra =[', ' get(handles.edit8,'String') ];
                
            otherwise
                %distancies simples nomes necesitem un numero
                vk=[ '[' get(handles.edit2,'String') ' ' get(handles.edit2,'String')  ']' ];
        end
        
        inst=[mcbr '.retrieve(' dade ',' vk ',' num2str(dc) extra ');'];
        [index ~]=evalin('base',inst);
        
        
        %si no te noms de lot els generem asignant-hi la posicio actual del
        %lot!!
        
        %noms al test
        noms=evalin('base',[dade '.getBatchLabel()']);
        if(isempty(noms) && (evalin('base',[dade '.getBatchCount()']) > 0))
            evalin('base',[dade '.setBatchLabel(num2cell(1:' dade '.getBatchCount))']);
            warndlg('Selected object had no batch names. Automatic ones ware assigned.','Attention!')
        end
        
        %noms a la C_B
        noms=evalin('base',[mcbr '.getCaseBase.getBatchLabel()']);
        if(isempty(noms) && (evalin('base',[mcbr '.getCaseBase.getBatchCount()']) > 0))
            evalin('base',[mcbr '.getCaseBase.setBatchLabel(num2cell(1:' mcbr '.getCaseBase.getBatchCount));']);
            warndlg('Selected object had no batch names. Automatic ones ware assigned.','Attention!')
        end
        
        
        [~, class noms] = evalin('base',[mcbr '.getCase([' num2str(index(:)') '])']);
        
        class=reshape(class,size(index,1),size(index,2));
        noms=reshape(noms,size(index,1),size(index,2));
        
    else
        inst=[mcbr '.retrieve(' dade ');'];
        [index ~]=evalin('base',inst);
        [~, class noms] = evalin('base',[mcbr '.getCase([' num2str(index(:)') '])']);
        class=reshape(class,size(index,1),size(index,2));
        noms=reshape(noms,size(index,1),size(index,2));
        
        %ya no es poden modificar ms!!
        set(handles.edit8,'enable','off');
        set(handles.edit2,'enable','off');
        set(handles.popupmenu3,'enable','off');
        set(handles.popupmenu4,'enable','off');
    end
    
    auxi=[];
    for i=1:size(noms,2)
        auxi=[auxi noms{i} '  '];
    end
    set(handles.listbox1,'String',{'Class:'   num2str(class) 'Name:' auxi})
    set(handles.listbox1,'value',length(get(handles.listbox1,'String')));
    
    set(handles.listbox1,'Visible','on');
    axes(handles.axes1);
    cla(gcf);
    set(handles.axes1,'Visible','off');
    datacursormode off
    
catch err
    errordlg(err.message,'Error');
end

function pushbutton3_Callback(~, ~, handles)
% Reuse
try
    %recuperem les dades
    variable=get(handles.popupmenu1,'String');
    mcbr=variable{get(handles.popupmenu1,'Value')};

    
    metode=num2str(get(handles.popupmenu3,'Value'));
    
    if evalin('base',[mcbr '.isOptimized();']) == 0
        inst=[mcbr '.reuse(' metode ');'];
        clase=evalin('base',inst);
    else
        inst=[mcbr '.reuse();'];
        clase=evalin('base',inst);
        
        %ya no es poden modificar ms!!
        set(handles.edit8,'enable','off');
        set(handles.edit2,'enable','off');
        set(handles.popupmenu3,'enable','off');
        set(handles.popupmenu4,'enable','off');
    end
    
    set(handles.listbox1,'String',{'Class:'   num2str(clase) })
    set(handles.listbox1,'value',length(get(handles.listbox1,'String')));
    
    set(handles.listbox1,'Visible','on');
    axes(handles.axes1);
    cla(gcf);
    set(handles.axes1,'Visible','off');
    datacursormode off
catch err
    errordlg(err.message,'Error');
end

function pushbutton4_Callback(~, ~, handles)
% Revise
try
    %recuperem les dades
    variable=get(handles.popupmenu1,'String');
    mcbr=variable{get(handles.popupmenu1,'Value')};

    
    variable=get(handles.popupmenu10,'String');
    dades=variable{get(handles.popupmenu10,'Value')};

    
    %hem de fer un reuse per poder saver quina classe li assignava i poder
    %fer el Plot_Confusion_Matrix! si no no caldria
    inst=[mcbr '.reuse();'];
    classp=evalin('base',inst);

    %el revise
    inst=[mcbr '.revise();'];
    [matri ~]=evalin('base',inst);
      
    
    %necesitem la classe real per fer el Plot_Confusion_Matrix
    classreal = evalin('base',[dades '.getClass();']);
    
    %posem el axes a visible i el listbox a invisible
    set(handles.axes1,'Visible','on');
    set(handles.listbox1,'Visible','off');
    
    axes(handles.axes1);
    %netejo l'axes per evitar solapaments i coses rares
    cla(gcf);
    
    %fem el plot, en detectar que nomes hi ha una partici fara servir el
    %current axes
    Plot_Confusion_Matrix({classp},{classreal},max(unique(classreal,classp)),evalin('base',[dades '.copy();']),{matri});
    
    %abilitem el datatip perque l'usuari no ho pot fer des de la UI
    datacursormode on
    
catch err
    errordlg(err.message,'Error');
end

function pushbutton5_Callback(~, ~, handles)
% Retain
try
    %recuperem les dades
    variable=get(handles.popupmenu1,'String');
    mcbr=variable{get(handles.popupmenu1,'Value')};

    
    %ens cal fer un revise per saver quins fallen!
    inst=[ mcbr '.revise();'];
    [~, fallen] = evalin('base',inst);
    
    %invoquem el retain
    inst=[mcbr '.retain([' num2str(fallen) '] == 1);'];
    evalin('base',inst);
    
    

    %pie per la C_B
    model=evalin('base',[mcbr '.getCaseBase();']);
    uni =  max(unique(model.getClass));
        uni = 1:uni;
    for i = uni
        su(i) = sum(model.getClass == i);
    end
    ind = (su ~=0);
    pie(handles.axes3,su(ind) ,uni(ind));
    legend(handles.axes3,char2cell(num2str(uni(ind))),'Location','BestOutside')
        
   
    set(handles.text43,'String',model.getBatchCount());
    set(handles.listbox3,'String',model.getBatchLabel());
    
catch err
    errordlg(err.message,'Error');
end

function pushbutton6_Callback(~, ~, handles)
%optimitza

%fem un retrieve per evitar problemes!
pushbutton2_Callback(-1, -1, handles);

try
    %recuperem les dades
    variable=get(handles.popupmenu1,'String');
    mcbr=variable{get(handles.popupmenu1,'Value')};

    
    net=get(handles.popupmenu2,'string');
    net=net{get(handles.popupmenu2,'Value')};
    
    if evalin('base',[mcbr '.isOptimized();']) == 0
        dc=get(handles.popupmenu4,'Value');
        metode=num2str(get(handles.popupmenu3,'Value'));
        
        switch dc
            case 4
                %distancies dobles
                vk=[ '[' get(handles.edit2,'String') ' ' get(handles.edit8,'String')  ']' ];
            case 5
                %distancies dobles
                vk=[ '[' get(handles.edit2,'String') ' ' get(handles.edit8,'String')  ']' ];
            case 6
                %distancies dobles
                vk=[ '[' get(handles.edit2,'String') ' ' get(handles.edit8,'String')  ']' ];
                
            case 17
                %distancia simple mes parametre extra
                vk=[ '[' get(handles.edit2,'String') ' ' get(handles.edit2,'String')  ']' ];
                metode = [metode ', ' get(handles.edit8,'String') ];
                
            case 18
                %distancia simple mes parametre extra
                vk=[ '[' get(handles.edit2,'String') ' ' get(handles.edit2,'String')  ']' ];
                metode = [metode ', ' get(handles.edit8,'String') ];
            otherwise
                %distancies simples nomes necesitem un numero
                vk=[ '[' get(handles.edit2,'String') ' ' get(handles.edit2,'String')  ']' ];
        end
        
        if get(handles.popupmenu2,'Value') < 4
            inst=[mcbr '.' net '(' vk ',' num2str(dc) ',' metode ');'];
            evalin('base',inst);
        elseif get(handles.popupmenu2,'Value')==4
            inst=[mcbr '.' net '(' get(handles.edit5,'String') ',' get(handles.edit6,'String') ',' vk ',' num2str(dc) ','  metode ');'];
            evalin('base',inst);
        end
    else
        if get(handles.popupmenu2,'Value') < 4
            inst=[mcbr '.' net '();'];
            evalin('base',inst);
        elseif get(handles.popupmenu2,'Value')==4
            inst=[mcbr '.' net '(' get(handles.edit5,'String') ',' get(handles.edit6,'String') ');'];
            evalin('base',inst);
        end
        
    end
    
    
    %ya no es poden modificar ms!!
    set(handles.edit2,'enable','off');
    set(handles.edit8,'enable','off');
    set(handles.popupmenu3,'enable','off');
    set(handles.popupmenu4,'enable','off');
       
    %lo mateix per la C_B
    model=evalin('base',[mcbr '.getCaseBase();']);
    uni =  max(unique(model.getClass));
        uni = 1:uni;
    for i = uni
        su(i) = sum(model.getClass == i);
    end
    ind = (su ~=0);
    pie(handles.axes3,su(ind) ,uni(ind));
    legend(handles.axes3,char2cell(num2str(uni(ind))),'Location','BestOutside')
        

    set(handles.text43,'String',model.getBatchCount());
    set(handles.listbox3,'String',model.getBatchLabel());
    
catch err
    errordlg(err.message,'Error');
end

function popupmenu10_Callback(~, ~, handles)
%han escollit unes dades
set(handles.pushbutton2,'Enable','on');

function pushbutton7_Callback(~, ~, ~)
%bolen entrar mes dades
uiwait(Menu_Load_Dades());

function popupmenu2_Callback(~, ~, handles)

if get(handles.popupmenu2,'Value') == 4 %IBUdG
    set(handles.edit5,'Visible','on');
    set(handles.edit6,'Visible','on');
    set(handles.text15,'Visible','on');
    set(handles.text16,'Visible','on');
else
    set(handles.edit5,'Visible','off');
    set(handles.edit6,'Visible','off');
    set(handles.text15,'Visible','off');
    set(handles.text16,'Visible','off');
end

function popupmenu4_Callback(~, ~, handles)
%selector de distancies callback

%segons la distancia escollida canviem la aparena de la ui
switch get(handles.popupmenu4,'value')
    case 4
        set(handles.text5,'string','Number of cases to retrieve (Q)')
        set(handles.text28,'string','Number of cases to retrieve (T^2)')
        set(handles.text28,'visible','on');
        set(handles.edit8,'visible','on');
        
    case 5
        set(handles.text5,'string','Number of cases to retrieve (Q)')
        set(handles.text28,'string','Number of cases to retrieve (PC)')
        set(handles.text28,'visible','on');
        set(handles.edit8,'visible','on');
        
    case 6
        set(handles.text5,'string','Number of cases to retrieve (T^2)')
        set(handles.text28,'string','Number of cases to retrieve (PC)')
        set(handles.text28,'visible','on');
        set(handles.edit8,'visible','on');
        
    case 17
        set(handles.text5,'string','Number of cases to retrieve')
        set(handles.text28,'string','distance parameter')
        set(handles.text28,'visible','on');
        set(handles.edit8,'visible','on');
        
    case 18
        set(handles.text5,'string','Number of cases to retrieve')
        set(handles.text28,'string','distance parameter')
        set(handles.text28,'visible','on');
        set(handles.edit8,'visible','on');
        
    otherwise
        %distancies d'1 nivell i sense parametres extres
        set(handles.text5,'string','Number of cases to retrieve')
        set(handles.text28,'visible','off');
        set(handles.edit8,'visible','off');
        
end

function popupmenu1_Callback(~, ~, handles)
%recuperem les dades
variable=get(handles.popupmenu1,'String');
mcbr=variable{get(handles.popupmenu1,'Value')};


%posem la UI com toca despres de seleccionar un objecte
set(handles.pushbutton7,'enable','on');
set(handles.pushbutton6,'enable','on');
set(handles.pushbutton5,'enable','on');
set(handles.pushbutton4,'enable','on');
set(handles.pushbutton3,'enable','on');
set(handles.pushbutton2,'enable','on');
set(handles.pushbutton10,'enable','on');
set(handles.pushbutton11,'enable','on');

set(handles.popupmenu10,'enable','on');
set(handles.popupmenu4,'enable','on');
set(handles.popupmenu3,'enable','on');
set(handles.popupmenu2,'enable','on');

set(handles.popupmenu10,'value',1);
set(handles.popupmenu4,'value',1);
set(handles.popupmenu3,'value',1);
set(handles.popupmenu2,'value',1);

set(handles.edit8,'enable','on');
set(handles.edit2,'enable','on');


if evalin('base',[mcbr '.isOptimized();']) == 0
    % Es poden modificar VK,DC i metode seleccio veins
    set(handles.edit2,'enable','on');
    set(handles.edit8,'enable','on');
    set(handles.popupmenu3,'enable','on');
    set(handles.popupmenu4,'enable','on');
else
    %No es poden modificar VK,DC i metode seleccio veins
    set(handles.edit2,'enable','off');
    set(handles.edit8,'enable','off');
    set(handles.popupmenu3,'enable','off');
    set(handles.popupmenu4,'enable','off');
    
end

%Si VK,DC i metode seleccio veins els hem fet servir algun cop els
%posem directament per estalviar feina a l'usuari
aux1 = evalin('base',[mcbr '.getMethod();']);
if~isempty(aux1)
    set(handles.popupmenu3,'Value',aux1);
end

aux1 = evalin('base',[mcbr '.getDC();']);
if~isempty(aux1)
    set(handles.popupmenu4,'Value',aux1);
end

aux = evalin('base',[mcbr '.getVK();']);
if~isempty(aux)
    set(handles.edit2,'String', num2str(aux(1)));
    set(handles.edit8,'String',num2str(aux(2)));
    if aux1 ==17 || aux1 ==18
        set(handles.edit8,'String',evalin('base',[mcbr '.getParam();']));
    end
end


model=evalin('base',[mcbr '.getModel();']);
val={
    'Auto Scaling'
    'Group Scaling'
    'Continous Scaling'
    'Block Scaling'};
set(handles.text17,'String',val{model.getNormalizationMethod()+1});

val={
    'Manual'
'Kaiser'
'Manual - Scree Plot'
'Automatic  - Scree Plot'
'% variance explained'
'VRE'};
set(handles.text18,'String',val{model.getPCSelectionMethod()+1});

val={
    'No'
    'Yes'};
set(handles.text19,'String',val{model.getTrajectoryRemoval()+1});

val={
    'Batch Wise'
    'Variable Wise'};
set(handles.text20,'String',val{model.getUnfoldingMethod()+1});

val={
    ' 3 sigma'
    'Analiticaly'};
set(handles.text21,'String',val{model.getLimitMethod()+1});

val={
    'Only positive'
'Positive and negative'};
set(handles.text26,'String',val{model.getContMetode()+1});

    set(handles.text35,'String',model.getSampleCount());
    set(handles.text36,'String',model.getVariableCount());
    set(handles.text37,'String',model.getBatchCount());
    set(handles.text38,'String',model.getNum());
    set(handles.text39,'String',model.getT2Limit());
    set(handles.text40,'String',model.getQLimit());
    
    %piechart de les classes Model
    uni =  max(unique(model.getClass));
     uni = 1:uni;
    for i = uni
        su(i) = sum(model.getClass == i);
    end
    ind = (su ~=0);
    
    pie(handles.axes2,su(ind) ,uni(ind));
    legend(handles.axes2,char2cell(num2str(uni(ind))),'Location','SouthEastOutside')

    
    %lo mateix per la C_B
    model=evalin('base',[mcbr '.getCaseBase();']);
    uni =  max(unique(model.getClass));
        uni = 1:uni;
    for i = uni
        su(i) = sum(model.getClass == i);
    end
    ind = (su ~=0);
    pie(handles.axes3,su(ind) ,uni(ind));
    legend(handles.axes3,char2cell(num2str(uni(ind))),'Location','BestOutside')
        
    %i la info
    set(handles.text43,'String',model.getBatchCount());
    set(handles.listbox3,'String',model.getBatchLabel());

%Posem be els textos de veins
popupmenu4_Callback(-1, -1, handles)
popupmenu2_Callback(-1, -1, handles)

function pushbutton1_Callback(~, ~, ~)
uiwait(Menu_Crea_CBR());

function Update(hObject, ~, handles)
handles.output = hObject;
handles=menu(handles);
%Tornem a crear la llista d'objectes PCA
x=evalin('base','whos();');
list=[];
list2=[];
for i=1:length(x)
    if strcmp(x(i).class,'CBR') ~=0 
        list=[list; {x(i).name}];
    end
    
    if strcmp(x(i).class,'DATA') ~=0
        list2=[list2; {x(i).name}];
    end
end
if isempty(list)
    list={'No CBR objects in workspace'};
end

%busquem el valor que te el popupmenu actualment
nom=get(handles.popupmenu1,'String');
nom=nom{get(handles.popupmenu1,'Value')};

%busquem aquest nom entre la llista actual

val=find(strcmp(nom,list));
set(handles.popupmenu1,'String',list);

if isempty(val)
    set(handles.popupmenu1,'Value',1);
    
    %i desactivem els menus!
    set(handles.edit5,'Visible','off');
    set(handles.edit6,'Visible','off');
    set(handles.text15,'Visible','off');
    set(handles.text16,'Visible','off');
    
    %deshabilitem el que no es pot tocar fins a selecionar el CBR
    set(handles.pushbutton7,'enable','off');
    set(handles.pushbutton6,'enable','off');
    set(handles.pushbutton5,'enable','off');
    set(handles.pushbutton4,'enable','off');
    set(handles.pushbutton3,'enable','off');
    set(handles.pushbutton2,'enable','off');
    set(handles.pushbutton10,'enable','off');
    set(handles.pushbutton11,'enable','off');
    
    set(handles.popupmenu10,'enable','off');
    set(handles.popupmenu4,'enable','off');
    set(handles.popupmenu3,'enable','off');
    set(handles.popupmenu2,'enable','off');
    
    set(handles.edit8,'enable','off');
    set(handles.edit2,'enable','off');
    
else
    set(handles.popupmenu1,'Value',val);
end

%la llista de dades nomes cal actualitzar-la res mes

if isempty(list2)
    list2={'No DATA Objects in workspace'};
end
set(handles.popupmenu10,'String',list2);
set(handles.popupmenu10,'Value',1);
guidata(hObject, handles);

function pushbutton10_Callback(hObject, eventdata, handles)
%recuperem el nom del CBR
nom=get(handles.popupmenu1,'String');
nom=nom{get(handles.popupmenu1,'Value')};


%recuperem el nom del test
nom2=get(handles.popupmenu10,'String');
nom2=nom2{get(handles.popupmenu10,'Value')};


%fem un retrieve i un reuse si fa falta!
if isempty(evalin('base',[nom '.getVK()']))
    pushbutton2_Callback(hObject, eventdata, handles)
    pushbutton3_Callback(hObject, eventdata, handles)
end

Menu_Veure_Veins_2({evalin('base',[nom '.copy();'])},[evalin('base',[nom2 '.copy();'])],nom);

function pushbutton11_Callback(hObject, eventdata, handles)
%boto all 4 simplement invoquem els 4 calbacks!
pushbutton2_Callback(hObject, eventdata, handles)
pushbutton3_Callback(hObject, eventdata, handles)
pushbutton4_Callback(hObject, eventdata, handles)
pushbutton5_Callback(hObject, eventdata, handles)

%-------------------------------INUTILS------------------------------------
function edit8_Callback(~, ~, ~)
function edit8_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function popupmenu4_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edit2_Callback(~, ~, ~)
function edit2_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function listbox1_Callback(~, ~, ~)
function listbox1_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edit5_Callback(~, ~, ~)
function edit5_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edit6_Callback(~, ~, ~)
function edit6_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function popupmenu10_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function popupmenu2_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function popupmenu3_Callback(~, ~, ~)
function popupmenu3_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function popupmenu1_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in listbox3.
function listbox3_Callback(hObject, eventdata, handles)
% hObject    handle to listbox3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns listbox3 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox3


% --- Executes during object creation, after setting all properties.
function listbox3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
