function varargout = Menu_Configura_PCA(varargin)
%Pantalla pensada exclusivament per permetre configurar els objectes PCA
%o visualitzar-ne la configuracio.
%
%Per invocar directament des de consola aquesta pantalla nomes cal
%invocar-ne la funcio sense cap parametre extra:
%Menu_Configura_PCA();
%
%Tamb es pot invocar fent doble click sobre un objecte PCA del workspace.
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @Menu_Configura_PCA_OpeningFcn, ...
    'gui_OutputFcn',  @Menu_Configura_PCA_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

function Menu_Configura_PCA_OpeningFcn(hObject, ~, handles, varargin)
%funci que s'invoca en crear la finestra a varargin ens arriven el
%possibles parametres extres d'invocaci de Pantalla. No els
%utilitzarem per res. hObject i handles els modificarem.

handles.output = hObject;
guidata(hObject, handles);
set(handles.popupmenu1,'Enable','off');
set(handles.popupmenu2,'Enable','off');
set(handles.popupmenu3,'Enable','off');
set(handles.popupmenu4,'Enable','off');
set(handles.popupmenu5,'Enable','off');
set(handles.popupmenu7,'Enable','off');
set(handles.Guardar,'Enable','off');

x=evalin('base','whos();');
list=[];
for i=1:length(x)
    if strcmp(x(i).class,'PCA')
        list=[list; {x(i).name}];
    end
end
if isempty(list)
    list={'No hi ha cap objecte PCA'};
end
set(handles.popupmenu6,'String',list);

if ~isempty(varargin) %si ens passen parametres interpretem que es l'element que volen seleccionar!!
    ind =max(strcmp(list,varargin{1})' .* (1:length(list)));
    if(ind ~= 0)
        set(handles.popupmenu6,'value', ind); %posem l'element que ens passen per parametre com a seleccionat
        popupmenu6_Callback(-1,-1,handles);
    end
end

function Guardar_Callback(~, ~, handles)
try
    nom=get(handles.popupmenu6,'String');
    nom=nom{get(handles.popupmenu6,'Value')};
    
    
    if evalin('base',[nom '.isModel();']) %nomes si es model podem canviar aquests
        
        %BW o VW
        inst=[nom '.setUnfoldingMethod(' num2str(get(handles.popupmenu4,'Value')-1) ');'];
        evalin('base',inst);
        
        %fixem el metode d'estandaritzacio
        inst=[nom '.setNormalizationMethod(' num2str(get(handles.popupmenu1,'Value')) ');'];
        evalin('base',inst);
        
        %treure forma mitja
        inst=[nom '.setTrajectoryRemoval(' num2str(get(handles.popupmenu3,'Value')-1) ');'];
        evalin('base',inst);
        
        %fixem el metode de seleccio de components principals
        inst=[nom '.setPCSelectionMethod(' num2str(get(handles.popupmenu2,'Value')-1) ');'];
        evalin('base',inst);
        
        %calcullimits
        inst=[nom '.setLimitMethod(' num2str(get(handles.popupmenu5,'Value')-1) ');'];
        evalin('base',inst);
        
        %calcul contribucions
        inst=[nom '.setContributionMethod(' num2str(get(handles.popupmenu7,'Value')-1) ');'];
        evalin('base',inst);
        
    else
        errordlg('L''objecte pca que has seleccionat no es un model','Error')
        
        uiwait(handle(gcf));
    end
    
    close('Menu_Configura_PCA');
    Update_Caller();
    
catch err
    errordlg(err.message,'Error');
end

function popupmenu6_Callback(~, ~, handles)
nom=get(handles.popupmenu6,'String');
nom=nom{get(handles.popupmenu6,'Value')};


%fem que es mostri el que toca segons l'objecte!
set(handles.popupmenu1,'Value',evalin('base',[nom '.getNormalizationMethod();']));
set(handles.popupmenu2,'Value',evalin('base',[nom '.getPCSelectionMethod();'])+1);
set(handles.popupmenu3,'Value',evalin('base',[nom '.getTrajectoryRemoval();'])+1);
set(handles.popupmenu4,'Value',evalin('base',[nom '.getUnfoldingMethod();'])+1);
set(handles.popupmenu5,'Value',evalin('base',[nom '.getLimitMethod();'])+1);
set(handles.popupmenu7,'Value',evalin('base',[nom '.getContMetode();'])+1);

%activem o no segons toqui!
if evalin('base',[nom '.isModel();'])
    set(handles.popupmenu1,'Enable','on');
    set(handles.popupmenu2,'Enable','on');
    set(handles.popupmenu3,'Enable','on');
    set(handles.popupmenu4,'Enable','on');
    set(handles.popupmenu5,'Enable','on');
    set(handles.popupmenu7,'Enable','on');
    set(handles.Guardar,'Enable','on');
else
    set(handles.popupmenu1,'Enable','off');
    set(handles.popupmenu2,'Enable','off');
    set(handles.popupmenu3,'Enable','off');
    set(handles.popupmenu4,'Enable','off');
    set(handles.popupmenu5,'Enable','off');
    set(handles.popupmenu7,'Enable','off');
    set(handles.Guardar,'Enable','off');
end

function Update(hObject, ~, handles)
handles.output = hObject;

%Tornem a crear la llista d'objectes PCA
x=evalin('base','whos();');
list=[];
for i=1:length(x)
    if strcmp(x(i).class,'PCA')
        list=[list; {x(i).name}];
    end
end
if isempty(list)
    list={'No hi ha cap objecte PCA'};
end

%busquem el valor que te el popupmenu actualment
nom=get(handles.popupmenu6,'String');
nom=nom{get(handles.popupmenu6,'Value')};

%busquem aquest nom entre la llista actual

val=find(strcmp(nom,list));
set(handles.popupmenu6,'String',list);

if isempty(val)
    set(handles.popupmenu6,'Value',1);
    
    %i desactivem els menus!
    set(handles.popupmenu1,'Enable','off');
    set(handles.popupmenu2,'Enable','off');
    set(handles.popupmenu3,'Enable','off');
    set(handles.popupmenu4,'Enable','off');
    set(handles.popupmenu5,'Enable','off');
    set(handles.popupmenu7,'Enable','off');
    set(handles.Guardar,'Enable','off');
    
else
    set(handles.popupmenu6,'Value',val);
end

guidata(hObject, handles);

%-----------------------------INUTILS--------------------------------------
function popupmenu1_Callback(~, ~, ~)
function popupmenu1_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function popupmenu2_Callback(~, ~, ~)
function popupmenu2_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function popupmenu3_Callback(~, ~, ~)
function popupmenu3_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function popupmenu4_Callback(~, ~, ~)
function popupmenu4_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function popupmenu5_Callback(~, ~, ~)
function popupmenu5_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function popupmenu6_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function popupmenu7_Callback(~, ~, ~)
function popupmenu7_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function varargout = Menu_Configura_PCA_OutputFcn(~, ~, handles) 
varargout{1} = handles.output;
