function varargout = Menu_Crea_CBR(varargin)
%Pantalla per crear objectes CBR a partir de objectes tipus PCA i DATA
%presents al workspace. Els nous objectes CBR seran creats al orkspace amb
%el nom que indiqui l'usuari
%
%Per invocar directament des de consola aquesta pantalla nomes cal
%invocar-ne la funcio sense cap parametre extra:
%Menu_Crea_CBR();
%
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Menu_Crea_CBR_OpeningFcn, ...
                   'gui_OutputFcn',  @Menu_Crea_CBR_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

% --- Executes just before Menu_Crea_CBR is made visible.
function Menu_Crea_CBR_OpeningFcn(hObject, ~, handles, varargin)
%funci que s'invoca en crear la finestra a varargin ens arriven el
%possibles parametres extres d'invocaci de Pantalla. No els
%utilitzarem per res. hObject i handles els modificarem.

handles.output = hObject;
guidata(hObject, handles);

%busquem objectes dades
x=evalin('base','whos();');
list=[];
list2=[];
for i=1:length(x)
    if strcmp(x(i).class,'DATA')
       list=[list; {x(i).name}];
    end
    
    if strcmp(x(i).class,'PCA') ~=0
        if evalin('base',[x(i).name '.isModel();'])
            list2=[list2; {x(i).name}];
        end
    end
end
if isempty(list)
    list={'No DATA object in workspace'};
end
set(handles.popupmenu2,'String',list);

%busquem PCA i model
if isempty(list2)
    list2={'No PCA model in workspace'};
end
set(handles.popupmenu1,'String',list2);
set(handles.pushbutton3,'Enable','off');

% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(~, ~, ~)
uiwait(Menu_Crea_Model_PCA());

% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(~, ~, ~)
uiwait(Menu_Load_Dades());



function edit1_Callback(~, ~, handles)
set(handles.pushbutton3,'Enable','on');


% --- Executes during object creation, after setting all properties.
function edit1_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(~, ~, handles)
try
    %nom de l'objecte dades que fara de C_B
    dade=get(handles.popupmenu2,'String');
    dade=dade{get(handles.popupmenu2,'Value')};
    
    
    %si no te noms de lot els generem asignant-hi la posicio actual del lot!!
    if(isempty(evalin('base',[dade '.getBatchLabel()'])) && (evalin('base',[dade '.getBatchCount()']) > 0))
        evalin('base',[dade '.setBatchLabel(num2cell(1:' dade '.getBatchCount))']);
        warndlg('Selected case base object had no batch names. Automatic ones ware assigned.','Attention!')
    end


%nom del PCA que fara la funci de model
pc=get(handles.popupmenu1,'String');
pc=pc{get(handles.popupmenu1,'Value')};


%nom del CBR que crearem
nom=get(handles.edit1,'String');


if ~isempty(evalin('base',['whos([''' nom '''])'] ))
    choice = questdlg('Selected name is used, do you want to oberwrite?', 'Attention', 'Yes','No','No');
    switch choice
        case 'Yes'
            %Sobreescriure

            inst=[nom '=CBR(' pc ',' dade  ');'];
            evalin('base',inst);
            
            close('Menu_Crea_CBR');
            Update_Caller();
            
        case 'No'
            %No fer res
    end
else

    inst=[nom '=CBR(' pc ',' dade  ');'];
    evalin('base',inst);
    
    close('Menu_Crea_CBR');
    Update_Caller();
end

catch err
    errordlg(err.message,'Error');
end

function Update(hObject, ~, handles) 
handles.output = hObject;

%Tornem a crear la llista d'objectes DATA
x=evalin('base','whos();');
list=[];
list2=[];
for i=1:length(x)
    if strcmp(x(i).class,'DATA') ~=0
        list=[list; {x(i).name}];
    end

    if strcmp(x(i).class,'PCA') ~=0 
        if evalin('base',[x(i).name '.isModel();'])
            list2=[list2; {x(i).name}];
        end
    end
end
if isempty(list)
    list={'No DATA object in workspace'};
end

%busquem el valor que te el popupmenu actualment
nom=get(handles.popupmenu2,'String');
nom=nom{get(handles.popupmenu2,'Value')};

%busquem aquest nom entre la llista actual

val=find(strcmp(nom,list));
set(handles.popupmenu2,'String',list);

if isempty(val)
    set(handles.popupmenu2,'Value',1);
    
    %i desactivem els menus!
    set(handles.pushbutton3,'Enable','off');
    
else
    set(handles.popupmenu2,'Value',val);
end

%busquem PCA i model
if isempty(list2)
    list2={'No PCA model in workspace'};
end
%busquem el valor que te el popupmenu actualment
nom=get(handles.popupmenu1,'String');
nom=nom{get(handles.popupmenu1,'Value')};

%busquem aquest nom entre la llista actual

val=find(strcmp(nom,list2));
set(handles.popupmenu1,'String',list2);

if isempty(val)
    set(handles.popupmenu1,'Value',1);
    
    %i desactivem els menus!
    set(handles.pushbutton3,'Enable','off');
    
else
    set(handles.popupmenu1,'Value',val);
end

guidata(hObject, handles);

%--------------------------------INUTILS-----------------------------------
function varargout = Menu_Crea_CBR_OutputFcn(~, ~, handles) 
varargout{1} = handles.output;
function popupmenu1_Callback(~, ~, ~)
function popupmenu1_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function popupmenu2_Callback(~, ~, ~)
function popupmenu2_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
