function varargout = Menu_PCA(varargin)
%Pantalla que englova les funcinalitats de visualitzaci / Modificaci de
%PCA. Amb aquesta pantalla podrem modificar facilment la configuraci
%d'objectes PCA o realitzar grfics de control.
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Menu_PCA_OpeningFcn, ...
                   'gui_OutputFcn',  @Menu_PCA_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

function Menu_PCA_OpeningFcn(hObject, eventdata, handles, varargin)
%funci que s'invoca en crear la finestra a varargin ens arriven el
%possibles parametres extres d'invocaci de Pantalla. No els
%utilitzarem per res. hObject i handles els modificarem.

%Afegim el menu
handles.output = hObject;
handles=menu(handles);

%busquem tots els objectes de tipus PCA disponibles

x=evalin('base','whos();');
list=[];
for i=1:length(x)
    if strcmp(x(i).class,'PCA') ~=0
        list=[list; {x(i).name}];
    end
end
if isempty(list)
    list={'No PCA object in workspace'};
end
%posem la llista de noms al list corresponent
set(handles.popupmenu49,'String',list);

%invoquem una selecci d'objecte per fer que s'actualitzi tot
popupmenu49_Callback(hObject, eventdata, handles);

%posem l'ajuda dels plots (El primer es Contribucions de Q)
set(handles.edit1,'Visible','off');
info={
    'Select batches to see their contributions ->'
    };
set(handles.texthelp,'String',info);

%fem que es puguin selecciona diversos elements de la llista
set(handles.listbox1,'Max',999999);

guidata(hObject, handles);

function pushbutton25_Callback(~, ~, ~)
%new Projection
Menu_Projecta_Dades_PCA();

function pushbutton26_Callback(~, ~, ~)
%create new PCA
Menu_Crea_Model_PCA();

function popupmenu49_Callback(hObject, eventdata, handles)
%S'ha seleccionat un objecte

%Hi ha objecte?
nom=get(handles.popupmenu49,'string');
nom=nom{get(handles.popupmenu49,'value')};

if strcmp(nom,'No PCA object in workspace')
    %hi ha el missatge d'error
    
    %Deshabilitem tots els controls
    set(handles.popupmenu50,'Enable','off');
    set(handles.popupmenu51,'Enable','off');
    set(handles.popupmenu52,'Enable','off');
    set(handles.popupmenu53,'Enable','off');
    set(handles.popupmenu54,'Enable','off');
    set(handles.popupmenu55,'Enable','off');
    set(handles.popupmenu56,'Enable','off');
    set(handles.pushbutton29,'Enable','off');
    set(handles.pushbutton28,'Enable','off');
    set(handles.listbox1,'Enable','off');
    set(handles.uitable1,'Enable','off');
    set(handles.edit19,'Enable','off');
    set(handles.edit20,'Enable','off');
    set(handles.edit21,'Enable','off');
else
    
    
    
    %comprovem si es un model o no i activem/desactivem els controls que
    %calguin
    inst = [nom '.isModel()'];
    if(evalin('base',inst))
        %Es un model
        
        %Activem tots els controls
        set(handles.popupmenu50,'Enable','on');
        set(handles.popupmenu51,'Enable','on');
        set(handles.popupmenu52,'Enable','on');
        set(handles.popupmenu53,'Enable','on');
        set(handles.popupmenu54,'Enable','on');
        set(handles.popupmenu55,'Enable','on');
        set(handles.popupmenu56,'Enable','on');
        if evalin('base',[nom '.getUnfoldingMethod();'])+1 == 1
            set(handles.pushbutton29,'Enable','on');
        else
            set(handles.pushbutton29,'Enable','off');
        end
        set(handles.pushbutton28,'Enable','on');
        set(handles.listbox1,'Enable','on');
        set(handles.uitable1,'Enable','on');
        set(handles.edit19,'Enable','on');
        set(handles.edit20,'Enable','on');
        set(handles.edit21,'Enable','on');
        
    else
        %es una projecci
        set(handles.popupmenu50,'Enable','off');
        set(handles.popupmenu51,'Enable','off');
        set(handles.popupmenu52,'Enable','off');
        set(handles.popupmenu53,'Enable','off');
        set(handles.popupmenu54,'Enable','off');
        set(handles.popupmenu55,'Enable','off');
        set(handles.popupmenu56,'Enable','on');
        set(handles.pushbutton29,'Enable','off');
        set(handles.pushbutton28,'Enable','on');
        set(handles.listbox1,'Enable','on');
        set(handles.uitable1,'Enable','on');
        set(handles.edit19,'Enable','on');
        set(handles.edit20,'Enable','on');
        set(handles.edit21,'Enable','on');
        
    end
    
    %posem els selectors a la posici correcte
    set(handles.popupmenu50,'Value',evalin('base',[nom '.getNormalizationMethod();']));
    set(handles.popupmenu51,'Value',evalin('base',[nom '.getPCSelectionMethod();'])+1);
    set(handles.popupmenu52,'Value',evalin('base',[nom '.getTrajectoryRemoval();'])+1);
    set(handles.popupmenu53,'Value',evalin('base',[nom '.getUnfoldingMethod();'])+1);
    set(handles.popupmenu54,'Value',evalin('base',[nom '.getLimitMethod();'])+1);
    set(handles.popupmenu55,'Value',evalin('base',[nom '.getContMetode();'])+1);
    
    
    %Posem les dades de l'objecte DATA intern
    
    %actualitzem la llista dels batches
    dade2 = evalin('base',[nom '.getDATA();']);
    aux=dade2.getBatchLabel();
    
    %si no te noms de lot els generem asignant-hi la posicio actual del lot!!
    if(isempty(aux) && (evalin('base',[nom '.getBatchCount()']) > 0))
        evalin('base',[nom '.setBatchLabel(num2cell(1:' nom '.getBatchCount))']);
        warndlg('Selected object had no batch names. Automatic ones ware assigned.','Attention!')
    end
    
    set(handles.listbox1,'Value',1);
    set(handles.listbox1,'ListboxTop', 1);
    set(handles.listbox1,'String',aux);
    
    %Posem la Classe, Q i T^2
    listbox1_Callback(hObject, eventdata, handles)
    
    %Mostrem els valors de la taula
    
    aux = evalin('base',[nom '.getLambdaAll();']);
    taula=num2cell(aux);
    landi = evalin('base',[nom '.getLambdaAll();']);
    aux = sum(landi);
    
    aux2=landi / aux * 100;
    taula= [taula  num2cell(aux2)];
    
    taula= [taula num2cell(cumsum(aux2)) ];
    
    taula{ evalin('base',[nom '.getNum();']) ,4} = '  * Num *';
    index = find(landi==0,1,'first')-1;
    if ~isempty(index)
        taula=taula(1:(index),:);
    end
    set(handles.uitable1,'Data',taula);
    
    updateinfo( handles,nom);

end

function updateinfo(handles,nom)
    %posem la info
    set(handles.text77,'String',evalin('base',[nom '.getSampleCount();']));
    set(handles.text78,'String',evalin('base',[nom '.getVariableCount();']));
    set(handles.text79,'String',evalin('base',[nom '.getBatchCount();']));
    set(handles.text80,'String',evalin('base',[nom '.getNum();']));
    set(handles.text81,'String',evalin('base',[nom '.getT2Limit();']));
    set(handles.text82,'String',evalin('base',[nom '.getQLimit();']));
    
    %posem el piechart
    clases=evalin('base',[nom '.getClass();']);
    uni =  max(unique(clases));
    uni = 1:uni;
    for i = uni
        su(i) = sum(clases == i);
    end
    
    ind = (su ~=0);
    set(handles.axes1,'visible','on');
    pie(handles.axes1,su(ind) ,uni(ind));
    legend(handles.axes1,char2cell(num2str(uni(ind))),'Location','BestOutside');


function listbox1_Callback(~, ~, handles)
%seleccionen un element de la llista de batches

num=get(handles.listbox1,'value');

if size(num,1) ~= 1 || size(num,2) ~= 1
    set(handles.edit19,'String','-');
    set(handles.edit20,'String','-');
    set(handles.edit21,'String','-');
else
    %nomes ni ha 1 de seleccionat
    
    %nom de la variable
    nom=get(handles.popupmenu49,'String');
    nom=nom{get(handles.popupmenu49,'Value')};
    
    
    %valors per mostrar als displays
    Q=evalin('base',[nom '.getQ();']);
    T2=evalin('base',[nom '.getT2();']);
    class=evalin('base',[nom '.getClass();']);
    
    %es estrany pero podem tenir objectes sense classes
    if ~isempty(class)
        set(handles.edit19,'String',num2str(class(num)));
    else
        set(handles.edit19,'String','Empty');
    end
    
    %posem els valors al seu lloc
    set(handles.edit20,'String',num2str(Q(num)'));
    set(handles.edit21,'String',num2str(T2(num)'));
end
    
% ------------------Callbacks del menu desplegable-------------------------
function Delete_Callback(hObject, eventdata, handles)
%nom de l'objecte dades que s'esta mostran al list dret
dade=get(handles.popupmenu49,'String');
dade1=dade{get(handles.popupmenu49,'Value')};


%L'element sobre el qual s'ha cridat el menu indica el lot a eliminar!!
lot1=num2str(get(handles.listbox1,'Value'));%la posici del lot!

%comprobem que hi hagi batches seleccionats
if isempty(get(handles.listbox1,'String'))
    errordlg('Select one object!','Error');
else
    %construim la instruccio que l'eliminara
    inst=[  dade1 '.deleteBatch([' num2str(lot1) ']);'];
    evalin('base',inst);%la evaluo
    
    %actualitzem la llista dels batches
    aux=evalin('base',[dade1 '.getBatchLabel()']);
    set(handles.listbox1,'Value',length(aux));
    set(handles.listbox1,'String', aux);
    
    popupmenu49_Callback(hObject, eventdata, handles);
end
function PlotVars_Callback(~, ~, handles)
%comprovem que hi hagi algun lot seleccionat
if isempty(get(handles.listbox1,'String'))
    errordlg('Select one object!','Error');
else
    
    %nom de l'objecte dades que s'esta mostran al list dreta
    dade=get(handles.popupmenu49,'String');
    dade1=dade{get(handles.popupmenu49,'Value')};
    
    
    %L'element sobre el qual s'ha cridat el menu indica el lot a fer el plot
    lot=get(handles.listbox1,'Value');%la posici del lot!
    inst=[ dade1 '.getBatch([' num2str(lot) ']);'];
    [dades , ~, nom] = evalin('base',inst);
    
    %DATA hi tenim les variables en columnes
    m=floor(size(dades,2)/2);
    n=floor( (size(dades,2)+1)/2 );
    
    figure;
    
    objecte = evalin('base',[dade1 '.getDATA()']);
    tit = objecte.getVariableLabel(); 
    if isempty(tit)
        tit = 1:size(dades,2);
    end
    
    color_table = jet(size(dades,3));
    hold on;
    if(m == 0)
        m=1;
    end
    for i = 1:size(dades,2) %per cada variable
        subplot(m,n,i)
        if i == 1
            ti = {};%nem preparant el legend
            hold on;
            for j= 1:size(dades,3)%per cada variable
                plot(1:size(dades,1),dades(:,i,j),'color',color_table(j,:))
                ti = {ti{:} ['Batch:' num2str(nom{j}) ' -- Object:' dade1]};
            end
            hold off;
        else
            %nomes cal calcular la llegenda 1 cop!
            hold on;
            for j= 1:size(dades,3)%per cada variable
                plot(1:size(dades,1),dades(:,i,j),'color',color_table(j,:))
            end
            hold off;
        end
        title(tit(i))
        legend(ti)
        legend('off')
    end
    hold off;
end
function CanviaClasse_Callback(~, ~, handles)
if isempty(get(handles.listbox1,'String'))
    errordlg('Select one object!','Error');
else
    %nom de l'objecte dades2
    dade=get(handles.popupmenu49,'String');
    dade2=dade{get(handles.popupmenu49,'Value')};
    
    
    class = evalin('base',[dade2 '.getClass()']);
    index = get(handles.listbox1,'Value');%la posici del lot a canviar
    
     answer = inputdlg('Wich class should have?');
     answer = str2double(answer);
     
     while isnan(answer)
         errordlg('Classes must be Integer!','Error')

         uiwait(gcf);
        answer = inputdlg('Wich class should have?');
        answer = str2double(answer);
     end
    
     if ~isempty(answer)
         class(index) = answer;
         evalin('base',[dade2 '.setClass([' num2str(class) ']);']);
         set(handles.edit19,'String',num2str(answer));
         updateinfo( handles,dade2);
     end
end
function CanviaNom_Callback(~, ~, handles)
if isempty(get(handles.listbox1,'String'))
    errordlg('select one object!','Error');
else
    %nom de l'objecte dades2
    dade=get(handles.popupmenu49,'String');
    dade2=dade{get(handles.popupmenu49,'Value')};
    
    
    class = evalin('base',[dade2 '.getBatchLabel()']);
    index = get(handles.listbox1,'Value');%la posici del lot a canviar
    
     answer = inputdlg('Which name should have?');
    
     if ~isempty(answer)
         class(index) = answer;
         aux =  evalin('base',[dade2 '.copy();']);
         aux.setBatchLabel(class);
         
         assignin('base',dade2, aux);

         set(handles.listbox1,'value', 1)
         set(handles.listbox1,'String', class)
                  
     end
end

% --------Quan acciona el submenu seleccionem l'element de la llista-------
function List1_Callback(~, ~, handles)
%fem un click dret per seleccionar l'element de la llista

if length(get(handles.listbox1,'Value')) <= 1
    R=java.awt.Robot;
    R.setAutoWaitForIdle(1);
    R.mousePress(java.awt.event.InputEvent.BUTTON1_MASK);
    R.mouseRelease(java.awt.event.InputEvent.BUTTON1_MASK);
end

%boto fer plots i listbox plots per el help plots
function pushbutton28_Callback(~, ~, handles)
%Fem el Plot que ens demanen!

nom=get(handles.popupmenu49,'String');
nom=nom{get(handles.popupmenu49,'Value')};


switch get(handles.popupmenu56,'Value')
    case 1
        figure();
        %Recuperem la llista de batches seleccionats
        aux=get(handles.listbox1,'Value');%la posici del lot!
        inst=[nom '.plotQContribution([' num2str(aux) ']);'];
    case 2
        figure();
        %Recuperem la llista de batches seleccionats
        aux=get(handles.listbox1,'Value');%la posici del lot!
        inst=[nom '.plotT2Contribution([' num2str(aux) ']);'];
    case 3
        figure();
        inst=[nom '.plotT2Q();'];
    case 4
        figure();
        inst=[nom '.plotScores(' get(handles.edit1,'String') ');'];
    case 5
        figure();
        inst=[nom '.plotVarianceCaptured();'];
    case 6
        figure();
        inst=[nom '.plotQSignatures();'];
    case 7
        figure();
        inst=[nom '.plotT2Signatures();'];
    case 8
        figure();
        inst=[nom '.plotScreePlot();'];
    case 9
        figure();
        inst=[nom '.plotMean();'];
    case 10
        figure();
        inst=[nom '.plotStd();'];
    case 11
        figure();
        inst=[nom '.plotP(' get(handles.edit1,'String') ');'];
    case 12
        figure();
        inst=[nom '.plotLoadings(' get(handles.edit1,'String') ');'];
    case 13
        PlotVars_Callback(-1,-1,handles);
    case 14
        inst=[nom '.plotOutLiers();'];
end
if exist('inst','var')
    try
        evalin('base',inst);
    catch err
        errordlg(err.message,'Error');
    end
end

function popupmenu56_Callback(hObject, ~, handles)
switch get(hObject,'value')
    % Contribucions al limit de Q
    case 1
        set(handles.edit1,'Visible','off');
        info={
            'Select batches to see their contributions ->'
            };
        
        set(handles.texthelp,'String',info);
        
        
    % Contribucions al limit de T^2    
    case 2
        set(handles.edit1,'Visible','off');
        info={
            'Select batches to see their contributions ->'
            };
        
        set(handles.texthelp,'String',info);
        
        
        % T^2 - Q
    case 3
        set(handles.edit1,'Visible','off');
        info={
            ''
            };
        
        set(handles.texthelp,'String',info);
        
        
        % Components Principals
    case 4
        set(handles.edit1,'Visible','on');
        info={
            '^'
            'Insert the number of score you want to see'
            'Correct formats are:'
            'double -> T(x) vs time'
            'double,double -> T(x) vs T(y)'
            'double,double,double -> T(x) vs T(y) vs T(z)'
            };
        
        set(handles.texthelp,'String',info);
        
        
        % % explicat
    case 5
        set(handles.edit1,'Visible','off');
        info={
            ''
            };
        
        set(handles.texthelp,'String',info);
        
        
        % Signatures de Q
    case 6
        set(handles.edit1,'Visible','off');
        info={
            ''
            };
        
        set(handles.texthelp,'String',info);
        
        
        % Signatures de T^2
    case 7
        set(handles.edit1,'Visible','off');
        info={
            ''
            };
        
        set(handles.texthelp,'String',info);
        
        
        % Lambda
    case 8
        set(handles.edit1,'Visible','off');
        info={
            ''
            };
        
        set(handles.texthelp,'String',info);
        
        
        % Mitja
    case 9
        set(handles.edit1,'Visible','off');
        info={
            ''
            };
        
        set(handles.texthelp,'String',info);
        
        
        % Desviacio estandard
    case 10
        set(handles.edit1,'Visible','off');
        info={
            ''
            };
        
        set(handles.texthelp,'String',info);
        

        % P
    case 11
        set(handles.edit1,'Visible','on');
        info={
            '^'
            'You must introduce the Index of the P you want to see.'
            'Correct formats are:'
            'double'
            '[double]'
            'Matlab Expressions'
            };
        
        set(handles.texthelp,'String',info);
        
        
        % PC
    case 12
        set(handles.edit1,'Visible','on');
        info={
            '^'
            'Insert the number of Principal Component you want to see'
            'Correct formats are:'
            'double -> PC(x) vs time'
            'double,double -> PC(x) vs PC(y)'
            'double,double,double -> PC(x) vs PC(y) vs PC(z)'
            };
        
        set(handles.texthelp,'String',info);
        
        
        %variables
    case 13
        set(handles.edit1,'Visible','off');
        info={
            'Select batches to see their variables ->'
            };
        
        set(handles.texthelp,'String',info);
    case 14
         set(handles.edit1,'Visible','off');
        info={
            ''
            };
        
        set(handles.texthelp,'String',info);
    otherwise
        errordlg('Unsuported Plot method!','Error')
end
 
%Callbacks de Configuracions (Guarden els valors a l'objecte)
function popupmenu50_Callback(hObject, eventdata, handles)
try
    nom=get(handles.popupmenu49,'String');
    nom=nom{get(handles.popupmenu49,'Value')};
    
    
    if evalin('base',[nom '.isModel();']) %nomes si es model podem canviar aquests
        
        %fixem el metode d'estandaritzacio
        inst=[nom '.setNormalizationMethod(' num2str(get(handles.popupmenu50,'Value')) ');'];
        evalin('base',inst);
               
    else
        %No hauria d'arrivar mai ja que el boto esta desactivat si no es un
        %model
        
        errordlg('Selected object is not a Model','Error')
        
        uiwait(handle(gcf));
    end
    
    %fem que actualitzi els valors de tot
    popupmenu49_Callback(hObject, eventdata, handles);
    
catch err
    errordlg(err.message,'Error');
end
function popupmenu51_Callback(hObject, eventdata, handles)
try
    nom=get(handles.popupmenu49,'String');
    nom=nom{get(handles.popupmenu49,'Value')};
    
    
    if evalin('base',[nom '.isModel();']) %nomes si es model podem canviar aquests
        
        %fixem el metode de seleccio de components principals
        inst=[nom '.setPCSelectionMethod(' num2str(get(handles.popupmenu51,'Value')-1) ');'];
        evalin('base',inst);
        
        
    else
        %No hauria d'arrivar mai ja que el boto esta desactivat si no es un
        %model
        
        errordlg('Selected object is not a Model','Error')       
        uiwait(handle(gcf));
    end
    
    %fem que actualitzi els valors de tot
    popupmenu49_Callback(hObject, eventdata, handles);
    
catch err
    errordlg(err.message,'Error');
end
function popupmenu52_Callback(hObject, eventdata, handles)
try
    nom=get(handles.popupmenu49,'String');
    nom=nom{get(handles.popupmenu49,'Value')};
    
    
    if evalin('base',[nom '.isModel();']) %nomes si es model podem canviar aquests
        
        %treure forma mitja
        inst=[nom '.setTrajectoryRemoval(' num2str(get(handles.popupmenu52,'Value')-1) ');'];
        evalin('base',inst);
         
    else
        %No hauria d'arrivar mai ja que el boto esta desactivat si no es un
        %model
        
        errordlg('Selected object is not a Model','Error')
        
        uiwait(handle(gcf));
    end
    
    %fem que actualitzi els valors de tot
    popupmenu49_Callback(hObject, eventdata, handles);
    
catch err
    errordlg(err.message,'Error');
end
function popupmenu53_Callback(hObject, eventdata, handles)
try
    nom=get(handles.popupmenu49,'String');
    nom=nom{get(handles.popupmenu49,'Value')};
    
    
    if evalin('base',[nom '.isModel();']) %nomes si es model podem canviar aquests
        
        %BW o VW
        inst=[nom '.setUnfoldingMethod(' num2str(get(handles.popupmenu53,'Value')-1) ');'];
        evalin('base',inst);
        
    else
        %No hauria d'arrivar mai ja que el boto esta desactivat si no es un
        %model
        
        errordlg('Selected object is not a Model','Error')
        
        uiwait(handle(gcf));
    end
    
    %fem que actualitzi els valors de tot
    popupmenu49_Callback(hObject, eventdata, handles);
    
catch err
    errordlg(err.message,'Error');
end
function popupmenu54_Callback(hObject, eventdata, handles)
try
    nom=get(handles.popupmenu49,'String');
    nom=nom{get(handles.popupmenu49,'Value')};
    
    
    if evalin('base',[nom '.isModel();']) %nomes si es model podem canviar aquests
        

        %calcullimits
        inst=[nom '.setLimitMethod(' num2str(get(handles.popupmenu54,'Value')-1) ');'];
        evalin('base',inst);
        
        
    else
        %No hauria d'arrivar mai ja que el boto esta desactivat si no es un
        %model
        
        errordlg('Selected object is not a Model','Error')
        
        uiwait(handle(gcf));
    end
    
    %fem que actualitzi els valors de tot
    popupmenu49_Callback(hObject, eventdata, handles);
    
catch err
    errordlg(err.message,'Error');
end
function popupmenu55_Callback(hObject, eventdata, handles)
try
    nom=get(handles.popupmenu49,'String');
    nom=nom{get(handles.popupmenu49,'Value')};
    
    
    
    %calcul contribucions
    inst=[nom '.setContributionMethod(' num2str(get(handles.popupmenu55,'Value')-1) ');'];
    evalin('base',inst);
    
    %fem que actualitzi els valors de tot
    popupmenu49_Callback(hObject, eventdata, handles);
    
catch err
    errordlg(err.message,'Error');
end

%funci Update
function Update(hObject, eventdata, handles)
%Actualitzem el menu
handles=menu(handles);
guidata(hObject, handles); %guardem els canvis

%comprobem que l'objecte actual encara existeixi!
nom=get(handles.popupmenu49,'String');
nom=nom{get(handles.popupmenu49,'Value')};



inst = ['exist(''' nom ''')'];
if evalin('base', inst)
    %existeix
    x=evalin('base','whos();');
    list=[];
    for i=1:length(x)
        if strcmp(x(i).class,'PCA') ~=0
            list=[list; {x(i).name}];
        end
    end
    if isempty(list)
        list={'No PCA object in workspace'};
    end
    %posem la llista de noms al list corresponent
    set(handles.popupmenu49,'String',list);
    
    %busquem la posicio de l'objecte que teniem seleccionat i la activem
    set(handles.popupmenu49,'value',find(strcmp(list,nom),1,'first'));%
    
    %invoquem una selecci d'objecte per fer que s'actualitzi tot
    popupmenu49_Callback(hObject, eventdata, handles);
    
    
else
    %no existeix!!
    %busquem tots els objectes de tipus PCA disponibles
    
    x=evalin('base','whos();');
    list=[];
    for i=1:length(x)
        if strcmp(x(i).class,'PCA')
            list=[list; {x(i).name}];
        end
    end
    if isempty(list)
        list={'No PCA object in workspace'};
    end
    %posem la llista de noms al list corresponent
    set(handles.popupmenu49,'String',list);
    
    %invoquem una selecci d'objecte per fer que s'actualitzi tot
    popupmenu49_Callback(hObject, eventdata, handles);
end

function pushbutton29_Callback(hObject, eventdata, handles)
% Delete outliers
nom=get(handles.popupmenu49,'String');
nom=nom{get(handles.popupmenu49,'Value')};


% preguntem com bol treure outliers
choice = questdlg('which outliers?','All','All','Extreme','Extreme');
inst = [nom '.deleteOutLiers(''' choice ''');'];

a = 1;
while(a > 0)
a = evalin('base',inst);
end
popupmenu49_Callback(hObject, eventdata, handles);


% --------------------------------------------------------------------
%Funcions per saber en tot moment quina casella de la taula esta
%seleccionada per canviar el Num de components amb doble click secondari
function uitable1_ButtonDownFcn(hObject, eventdata, handles)
%quan es clica amb el secondari s'executa
persistent chk
set(hObject,'Interruptible','on');
nom=get(handles.popupmenu49,'String');
nom=nom{get(handles.popupmenu49,'Value')};


%comprobem que estigui habilitada i l'objecte sigui un model
if strcmp(get(handles.uitable1,'enable'),'on') && evalin('base',[nom '.isModel()'])
    if isempty(chk)
        chk = 1;
        pause(0.5); %Add a delay to distinguish single click from a double click
        if chk == 1
            %single click
            chk = [];
        end
    else
        %doble click
        chk = [];

        if length(get(handles.listbox1,'Value')) <= 1
            R=java.awt.Robot;
            R.setAutoWaitForIdle(1);
            R.mousePress(java.awt.event.InputEvent.BUTTON1_MASK);
            R.mouseRelease(java.awt.event.InputEvent.BUTTON1_MASK);           
        end
        pause(0.001); %Fem un delay per obligar a que entri l'interrupci de selecci en cas que s'hagi produit
        myhandles = guidata(gcbo);
        
        evalin('base',[nom '.setNum(' num2str(myhandles.selected(1)) ');']);
        popupmenu49_Callback(hObject, eventdata, handles)
    end
end

function uitable1_CellSelectionCallback(hObject, eventdata, handles)
%Quan es selecciona una casella s'executa
if(~exist('handles.selected','var'))
    handles.selected = [];
end
handles.selected=eventdata.Indices;
guidata(hObject, handles);

%------------------------------INUTILS-------------------------------------
function edit1_Callback(~, ~, ~)
function edit19_Callback(~, ~, ~)
function edit20_Callback(~, ~, ~)
function edit21_Callback(~, ~, ~)
function edit19_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edit20_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edit21_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function listbox1_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function popupmenu49_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function popupmenu50_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function popupmenu51_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function popupmenu52_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function popupmenu53_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function popupmenu54_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function popupmenu55_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function popupmenu56_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function varargout = Menu_PCA_OutputFcn(~, ~, handles) 
varargout{1} = handles.output;
function edit1_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
