function varargout = Menu_Projecta_Dades_PCA(varargin)
%Pantalla per crear projeccins a partir d'un objecte PCA-model i un
%objecte DATA que conte les dades a ser projectedes. Els 2 objectes s'han
%de trovar al workspace.
%
%L'objecte projectat se li asignara el nom escollit per l'usuari i es
%deixara al workspace.
%
%Per invocar directament des de consola aquesta pantalla nomes cal
%invocar-ne la funcio sense cap parametre extra:
%Menu_Projecta_Dades_PCA();
%
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Menu_Projecta_Dades_PCA_OpeningFcn, ...
                   'gui_OutputFcn',  @Menu_Projecta_Dades_PCA_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

function Menu_Projecta_Dades_PCA_OpeningFcn(hObject, ~, handles, varargin)
%funci que s'invoca en crear la finestra a varargin ens arriven el
%possibles parametres extres d'invocaci de Pantalla. No els
%utilitzarem per res. hObject i handles els modificarem.

handles.output = hObject;
guidata(hObject, handles);

%busquem objectes DATA i PCA i fem les 2 llistes de cop
x=evalin('base','whos();');
list=[];
list2=[];
for i=1:length(x)
    if strcmp(x(i).class,'DATA') ~=0
       list=[list; {x(i).name}];
    end
    
    if strcmp(x(i).class,'PCA') ~=0
        if evalin('base',[x(i).name '.isModel();'])
            list2=[list2; {x(i).name}];
        end
    end
end
%comprovem si ni havien i posem els valors al seu lloc
if isempty(list)
    list={'No DATA object in workspace'};
end
set(handles.dades,'String',list);
if isempty(list2)
    list2={'No PCA object in workspace'};
end
set(handles.PCAmodels,'String',list2);

function LoadPCA_Callback(~, ~, handles)
uiwait(Menu_Crea_Model_PCA());
%busquem PCA i model
x=evalin('base','whos();');
list=[];
for i=1:length(x)
    if strcmp(x(i).class,'PCA') ~=0
        if evalin('base',[x(i).name '.isModel();'])
            list=[list; {x(i).name}];
        end
    end
end
if isempty(list)
    list={'No DATA object in workspace'};
end
set(handles.PCAmodels,'String',list);

function pushbutton2_Callback(~, ~, handles)
uiwait(Menu_Load_Dades());
%busquem objectes dades
x=evalin('base','whos();');
list=[];
for i=1:length(x)
    if strcmp(x(i).class,'DATA') ~=0 
       list=[list; {x(i).name}];
    end
end
if isempty(list)
    list={'No DATA object in workspace'};
end
set(handles.dades,'String',list);

function Genera_Callback(~, ~, handles)
try
    %recuperem els noms del Model i de l'DATA
    variable=get(handles.dades,'String');
    variable=variable{get(handles.dades,'Value')};
    pc=get(handles.PCAmodels,'String');
    pc=pc{get(handles.PCAmodels,'Value')};
    
    %Nom que vol l'usuari a la variable
    nom=get(handles.edit1,'String');
    
    
    if ~isempty(evalin('base',['whos(''' nom ''')'] ))
        choice = questdlg('Selected name is in use, do you want to overwride?', 'Attention', 'Yes','No','No');
        switch choice
            case 'Si'
                %Sobreescriure
                inst=[ nom '=' pc '.project(' variable ');'];
                evalin('base',inst);
                
                close('Menu_Projecta_Dades_PCA');
                Update_Caller();
                
            case 'No'
                %No fer res
        end
    else
        %No hi ha nom repetit
        inst=[ nom '=' pc '.project(' variable ');'];
        evalin('base',inst);
        
        close('Menu_Projecta_Dades_PCA');
        Update_Caller();
    end
    
catch err
    errordlg(err.message,'Error');
end

function Update(hObject, ~, handles) 
handles.output = hObject;

%Tornem a crear la llista d'objectes DATA
x=evalin('base','whos();');
list=[];
list2=[];
for i=1:length(x)
    if strcmp(x(i).class,'DATA') ~=0 
        list=[list; {x(i).name}];
    end
    
    if strcmp(x(i).class,'PCA') ~=0 
        if evalin('base',[x(i).name '.isModel();'])
            list2=[list2; {x(i).name}];
        end
    end
end

%Actualitzem llista de DATA
if isempty(list)
    list={'No DATA object in workspace'};
end

%busquem el valor que te el popupmenu actualment
nom=get(handles.dades,'String');
nom=nom{get(handles.dades,'Value')};

%busquem aquest nom entre la llista actual

val=find(strcmp(nom,list));
set(handles.dades,'String',list);

if isempty(val)
    set(handles.dades,'Value',1);
       
else
    set(handles.dades,'Value',val);
end


%Actualitzem llista de PCA

%no cal tornar a fer el bucle ho hem posat tot en 1!
if isempty(list2)
    list2={'No PCA object in workspace'};
end

%busquem el valor que te el popupmenu actualment
nom=get(handles.PCAmodels,'String');
nom=nom{get(handles.PCAmodels,'Value')};

%busquem aquest nom entre la llista actual
val=find(strcmp(nom,list2));
set(handles.PCAmodels,'String',list2);

if isempty(val)
    set(handles.PCAmodels,'Value',1);
else
    set(handles.PCAmodels,'Value',val);
end

guidata(hObject, handles);

%----------------------------INUTILS---------------------------------------
function varargout = Menu_Projecta_Dades_PCA_OutputFcn(~, ~, handles) 
varargout{1} = handles.output;
function PCAmodels_Callback(~, ~, ~)
function PCAmodels_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function dades_Callback(~, ~, ~)
function dades_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edit1_Callback(~, ~, ~)
function edit1_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
