function varargout = Menu_Save_Dades(varargin)
%Pantalla per guardar objectes de tipus DATA del workspace a disc en
%diferents formats de fitxer (CSV, MAT,...)
%
%Per invocar directament des de consola aquesta pantalla nomes cal
%invocar-ne la funcio sense cap parametre extra:
%Menu_Save_Dades();
%
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Menu_Save_Dades_OpeningFcn, ...
                   'gui_OutputFcn',  @Menu_Save_Dades_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

function Menu_Save_Dades_OpeningFcn(hObject, ~, handles, varargin)
%funci que s'invoca en crear la finestra a varargin ens arriven el
%possibles parametres extres d'invocaci de Pantalla. No els
%utilitzarem per res. hObject i handles els modificarem.
handles.output = hObject;
guidata(hObject, handles);

%emplenem la llista de noms de variables
x=evalin('base','whos();');
list=[];
for i=1:length(x)
    if strcmp(x(i).class,'DATA') ~=0 
       list=[list; {x(i).name}];
    end
end
if isempty(list)
    list={'No DATA object in workspace'};
end
set(handles.Variables,'String',list);

function Escollir_Callback(~, ~, handles)
%boto escollir fitxer

%obrim la UI per defece d'escollir fitxers
[fitxer,ruta,~]=uiputfile('*.*');

if fitxer ~= 0
    %s'ha escollit un fitxer
    
    %posem el nom i ruta al camp correcte de la UI
    set(handles.Fitxer,'String',strcat(ruta,fitxer));

else
    %hi ha hagut algun error
    errordlg('No file selected','Error');

end

function Genera_Callback(~, ~, handles)
%l'usuari a apretat Guardar

%recuperem el nom de la variable seleccionada
variable=get(handles.Variables,'String');
variable=variable{get(handles.Variables,'Value')};

%recuperem el nom i ruta de fitxer escollit
fitxer=get(handles.Fitxer,'String');


if isempty(fitxer)
    %no hi ha fitxer escollit!
    errordlg('No file selected','Error');
    
else
    %recuperem el format de fitxer escollit
    format=get(handles.Format,'String');
    format=format{get(handles.Format,'Value')};
    
    %invoquem la funci corresponet de les llibreries
    evalin('base',[ variable '.save(''' fitxer ''',''' format ''');']);
    
    %ja hem acavat la feina -> tanquem la finestra actual
    close('Menu_Save_Dades');
end

function Update(hObject, ~, handles) 
handles.output = hObject;

%s'han crear/destruit objectes per tant s'ha d'actualitzar la llista en
%consequencia

%Tornem a crear la llista d'objectes DATA
x=evalin('base','whos();');
list=[];
for i=1:length(x)
    if strcmp(x(i).class,'DATA') ~=0 
        list=[list; {x(i).name}];
    end
end
if isempty(list)
    list={'No DATA object in workspace'};
end

%busquem el valor que te el popupmenu actualment
nom=get(handles.Variables,'String');
nom=nom{get(handles.Variables,'Value')};

%busquem aquest nom entre la llista actual
val=find(strcmp(nom,list));
set(handles.Variables,'String',list);

if isempty(val)
    %tenia seleccionat un objecte que ja no existeix -fem que apunti al
    %primer de la llista
    set(handles.Variables,'Value',1);
else
    %actualitzem la llista i fem que apunti a la variable correcte
    set(handles.Variables,'Value',val);
end

guidata(hObject, handles);

%--------------------------------INUTILS-----------------------------------
function Variables_Callback(~, ~, ~)
function Variables_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function Format_Callback(~, ~, ~)
function Format_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function Fitxer_Callback(~, ~, ~)
function varargout = Menu_Save_Dades_OutputFcn(~, ~, handles) 
varargout{1} = handles.output;
function Fitxer_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
