function varargout = Menu_Talla(varargin)
%Pantalla dissenyada per facilitar als usuaris l'us de la funci talla que
%permet crear nous objectes PCA, DATA i CBR ms especifics
%especialitzant-los en un subconjunt de variables o temps.
%
%Aquesta funcio/pantalla no necesita cap parametre d'entrada, en cas de
%requerir-se es retornara el handle de la figura com a paramete de sortida
%perque s el comportament general de totes les pantalles en matlab.

gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Menu_Talla_OpeningFcn, ...
                   'gui_OutputFcn',  @Menu_Talla_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

function Menu_Talla_OpeningFcn(hObject, ~, handles, varargin)
%funci que s'invoca en crear la finestra a varargin ens arriven el
%possibles parametres extres d'invocaci de Pantalla. No els
%utilitzarem per res. hObject i handles els modificarem.

%menu
handles.output = hObject;
handles=menu(handles);
guidata(hObject, handles);

%busquem objectes CBR,PCA i DATA
x=evalin('base','whos();');
list=[];
for i=1:length(x)
    if (strcmp(x(i).class,'CBR') ~=0 || strcmp(x(i).class,'PCA') ~=0 || strcmp(x(i).class,'DATA') ~=0 )
        list=[list; {x(i).name}];
    end
end
if isempty(list)
    list={'No objects in workspace'};
end
%posem la llista de noms
set(handles.popupmenu1,'String',list);

%fem invisibles tot el que de moment no s'ha de veure
set(handles.uipanel1,'Visible','off');
set(handles.uipanel2,'Visible','off');
set(handles.uipanel4,'Visible','off');
set(handles.axes1,'Visible','off');

%fem que s'activi tot segons que hi hagi seleccionat per defecte
popupmenu1_Callback([],[], handles);

function checkbox1_Callback(hObject, ~, handles)
%tots els instants de temps
if ~get(hObject,'Value')%activem o desactivem els edits
    set(handles.edit1,'enable','on');
    set(handles.edit2,'enable','on');
else
    set(handles.edit1,'enable','off');
    set(handles.edit2,'enable','off');   
end

function popupmenu1_Callback(~, ~, handles)
%seleccionen una variable

x=get(handles.popupmenu1,'string');
if ~strcmp(x{get(handles.popupmenu1,'Value')},'No objects in workspace')
    set(handles.uipanel1,'Visible','on');
    set(handles.uipanel2,'Visible','on');
    set(handles.uipanel4,'Visible','on');
    set(handles.axes1,'Visible','on');

    ruta = mfilename('fullpath');
    imatge = imread([fileparts(ruta) filesep 'Imatges' filesep 'Dades3D.jpg']);
    
    axes(handles.axes1);
    image(imatge);
    axis off;

    %nom de l'objecte dades que fara de C_B
    dade=get(handles.popupmenu1,'String');
    dade=dade{get(handles.popupmenu1,'Value')};
    
    
    x=evalin('base',['whos(''' dade ''');']);
    if strcmp(x.class,'CBR')
        set(handles.edit1,'string',{'1'});
        set(handles.edit2,'string',{ num2str(evalin('base',[dade '.getCaseBase.getSampleCount()']))});
        set(handles.edit3,'string',{ ['[1:' num2str(evalin('base',[dade '.getCaseBase.getVariableCount()'])) ']'] });
    end
    if strcmp(x.class,'PCA')
        set(handles.edit1,'string',{'1'});
        set(handles.edit2,'string',{ num2str(evalin('base',[dade '.getSampleCount()']))});
        set(handles.edit3,'string',{ ['[1:' num2str(evalin('base',[dade '.getVariableCount()'])) ']'] });
    end
    if strcmp(x.class,'DATA')
        set(handles.edit1,'string',{'1'});
        set(handles.edit2,'string',{ num2str(evalin('base',[dade '.getSampleCount()']))});
        set(handles.edit3,'string',{ ['[1:' num2str(evalin('base',[dade '.getVariableCount()'])) ']'] });
    end
end

function checkbox2_Callback(hObject, ~, handles)
%select all variables
if ~get(hObject,'Value')
    set(handles.edit3,'enable','on');
else
    set(handles.edit3,'enable','off');
end

function pushbutton1_Callback(~, ~, handles)
%nom de l'objecte dades que fara de C_B
dade=get(handles.popupmenu1,'String');
dade=dade{get(handles.popupmenu1,'Value')};


if get(handles.checkbox1,'Value')
    x=evalin('base',['whos(''' dade ''');']);
    if strcmp(x.class,'CBR')
        temps =['[1:' num2str(evalin('base',[dade '.getCaseBase.getSampleCount()'])) ']'];
    else
        temps =['[1:' num2str(evalin('base',[dade '.getSampleCount()'])) ']'];
    end
else
    temps = ['[' get(handles.edit1,'string') ':' get(handles.edit2,'string') ']'];
    temps = [temps{:}];
end

if get(handles.checkbox2,'Value')
    vars =''':''';
else
    vars =get(handles.edit3,'string');
    vars = [vars{:}];
end

%nom del CBR que crearem
nom=get(handles.edit4,'String');


if ~isempty(evalin('base',['whos([''' nom '''])'] ))
    choice = questdlg('Selected name is used, do you want to overwride?', 'Atencio', 'Yes','No','No');
    switch choice
        case 'Yes'
            %Sobreescriure
            %creem la variable
            inst=[nom '=talla(' dade  ',' vars ',' temps ');'];
            evalin('base',inst);
            
            close('Menu_Talla');
            Update_Caller();
            
        case 'No'
            %No fer res
    end
else
    %creem la variable
    inst=[nom '=talla(' dade  ',' vars ',' temps ');'];
    evalin('base',inst);
            
    close('Menu_Talla');
    Update_Caller();
end


%------------------------------INUTILS-------------------------------------
function popupmenu1_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edit3_Callback(~, ~, ~)
function edit3_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edit1_Callback(~, ~, ~)
function edit1_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edit2_Callback(~, ~, ~)
function edit2_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edit4_Callback(~, ~, ~)
function edit4_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function varargout = Menu_Talla_OutputFcn(~, ~, handles) 
varargout{1} = handles.output;
