function varargout = Menu_Veure_Veins_2(varargin)
%Aquesta pantalla mostra la informacio dels veins mes propers que s'han
%recuperat de la base de casos per a un seguit d'observacions. Aquesta
%pantalla necesita com a entrada un o diversos CBR i els respectius casos
%de test. 
%
%Aquesta pantalla creara les variables temporals (var_temp_Test,
%var_temp_CBR i temp_aux) no poden ser eliminades mentre la pantalla
%estigui oberta ja que provocaria errors greus.
%
%Aquesta pantalla s'invoca generalment des d'altres pantalles per fer-ho
%manualment cal indicar els parametres correctament. Primer un cell que
%contingui els CBR i a continuaci un list amb els objectes DATA (casos de
%test) corresponents en cada cas.
%
% Menu_Veure_Veins_2({CBR},[DATA]);
%
%

%Autogenerat - inicialitza tots els callbacks i parametres de la finesta
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Menu_Veure_Veins_2_OpeningFcn, ...
                   'gui_OutputFcn',  @Menu_Veure_Veins_2_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end


function Menu_Veure_Veins_2_OpeningFcn(hObject, ~, handles, varargin)
%funci que s'invoca en crear la finestra a varargin ens arriven els
% parametres extres en el nostre cas els CBR i DATA.

handles.output = hObject;
handles=menu(handles);


guidata(hObject, handles);

%busquem objectes CBR
if nargin < 5
    errordlg('We needparameters to open this window!','Error');

else
    
    x=varargin{1}{1};
    x=whos('x');
    list=[];
    if strcmp(x.class,'CBR') ~= 0 %es
         x=varargin{1};
          x=whos('x');
        for i=1:x.size(2)
            list=[list; {['Division ' num2str(i)]}];
        end
    end
    if isempty(list)
        list={'No CBR selected'};
    end
%    evalin('base','var_temp_CBR');
     assignin('base','var_temp_CBR', varargin{1});
    
%    evalin('base','var_temp_Test');
     assignin('base','var_temp_Test', varargin{2});
    
    set(handles.popupmenu1,'String',list);
    set(handles.uipanel2,'Visible','off');
    set(handles.uipanel4,'Visible','off');
    set(handles.uipanel8,'Visible','off');
    set(handles.pushbutton3,'Visible','off')
    
    %mirem si ens han passat un 3er parametre (venim de menu_CBR)
    if length(varargin) >= 3
         
        set(handles.popupmenu1,'String',{varargin{3}});
        set(handles.text1,'String','CBR variable name:')
        set(handles.popupmenu3,'String', {'Initial Test';'Other Tests'})
                
    end
end

function popupmenu1_Callback(hObject, ~, handles)

%recuperem el CBR
mcbr=get(handles.popupmenu1,'Value');% numero de partici (CBR i test si cal)

if get(handles.popupmenu3,'Value') == 1
    %Vol utilitzar la particio mcbr i el test mcbr
    
    %set(handles.listbox1,'String',evalin('base',['var_temp_Test(' num2str(mcbr) ').getBatchLabel();']));
    nom = ['var_temp_Test(' num2str(mcbr) ')'];
    %actualitzem la llista dels lots
    aux=evalin('base',[nom '.getBatchLabel()']);
    
    %si no te noms de lot els generem asignant-hi la posicio actual del lot!!
    if(isempty(aux) && (evalin('base',[nom '.getBatchCount()']) > 0))
        evalin('base',[nom '.setBatchLabel(num2cell(1:' nom '.getBatchCount))']);
        warndlg('Selected object had no batch names. Automatic ones ware assigned.','Attention!')

        aux=evalin('base',[nom '.getBatchLabel()']);
    end
    set(handles.listbox1,'String',aux);
    set(handles.listbox1,'Value',1);
    
    set(handles.listbox1,'Value',1);
    
    set(handles.listbox2,'String',{});
    set(handles.listbox2,'Value',1);
    
    set(handles.uipanel2,'Visible','off');
    
else
     %Vol utilitzar la particio mcbr i el test indicat al popupmenu4
    
     set(handles.uipanel2,'Visible','on');
    %busquem objectes de tipus DATA
    x=evalin('base','whos();');
    list=[];
    for i=1:length(x)
        if strcmp(x(i).class,'DATA') ~=0
            if not( strcmp(x(i).name,'var_temp_Test') || strcmp(x(i).name,'var_aux')) 
                list=[list; {x(i).name}];
            end
        end
    end
    if isempty(list)
        list={'No DATA objects in workspace'};
    end
    set(handles.popupmenu4,'String',list);
    if (get(handles.popupmenu4,'Value') > length(list))
        set(handles.popupmenu4,'Value',1); 
    end
     
     
     
    set(handles.listbox2,'String',{});
    set(handles.listbox2,'Value',1);
    
    variable=get(handles.popupmenu4,'String');
    nom=variable{get(handles.popupmenu4,'Value')};
    
    
    if isempty(strfind(nom,'No DATA objects in workspace'))

        %actualitzem la llista dels lots
        aux=evalin('base',[nom '.getBatchLabel()']);

        %si no te noms de lot els generem asignant-hi la posicio actual del lot!!
        if(isempty(aux) && (evalin('base',[nom '.getBatchCount()']) > 0))
            evalin('base',[nom '.setBatchLabel(num2cell(1:' nom '.getBatchCount))']);
            warndlg('Selected object had no batch names. Automatic ones ware assigned.','Attention!')
            aux=evalin('base',[nom '.getBatchLabel()']);
        end
        set(handles.listbox1,'String',aux);
        set(handles.listbox1,'Value',1);
    else
        set(handles.listbox1,'String',{});
        set(handles.listbox1,'Value',1);
    end
   
end

set(handles.uipanel4,'Visible','on');
set(handles.uipanel8,'Visible','on');

set(handles.text5,'String',[ '[ ' num2str(evalin('base',['var_temp_CBR{' num2str(mcbr) '}.getVK();'])) ' ]']);
dcs={
'Distance using Scores'
'Distance using T^2'
'Distance using Q'
'Distance using a combination of Q and T^2'
'Distance using a combination of Q and Scores'
'Distance using a combination of T^2 and Scores'
'Distance using Q Contributions with Euclidean distance'
'Distance using T^2 Contributions with Euclidean distance'
'Distance using Q Contributions with Mahalanobis (STD)'
'Distance using T^2 Contributions with Mahalanobis (STD)'
'Bi-dimencional distance using Q and T^2 '
'Distance using Q Signatures'
'Distance using T^2 Signatures'
'Distance using Q Signatures with phase grouping'
'Distance using T^2 Signatures with phase grouping'
'Distance using Scores (without normalization)'
'Distance using Q Signatures with binary phase grouping'
'Distance using T^2 Signatures with binary phase grouping'
};
aux1 = evalin('base',['var_temp_CBR{' num2str(mcbr) '}.getDC();']);
aux=dcs{aux1};

if aux1 == 17 || aux1==18
    aux= [aux ' param: ' num2str(evalin('base',['var_temp_CBR{' num2str(mcbr) '}.getParam();']))];
end
set(handles.text6,'String', aux );

mets={
'Weighted voting with Similitude ratio and class frequency'
'Simple voting'
'Weighted voting with Similitude ratio'
};
set(handles.text17,'String', mets{evalin('base',['var_temp_CBR{' num2str(mcbr) '}.getMethod();'])} );

%plot
axes(handles.axes1);
cla;
if isfield(handles, 'plot')
handles=rmfield(handles,'plot');
end
handles.plot.C_B=evalin('base',['var_temp_CBR{' num2str(mcbr) '}.getCaseBase.plotT2Q(''.'');']);
handles.plot.Mod=evalin('base',['var_temp_CBR{' num2str(mcbr) '}.getModel.plotT2Q(''O'',[],''no'');']);

%[dades class nom]=evalin('base',['var_temp_Test(' num2str(mcbr) ').getBatch(' num2str(get(handles.listbox1,'Value')) ');']);

evalin('base',['temp_aux=var_temp_Test(' num2str(mcbr) ').copy;']);
evalin('base',['temp_aux.deleteBatch([1:' num2str(get(handles.listbox1,'Value')-1) ' ' num2str(get(handles.listbox1,'Value')+1) ':temp_aux.getBatchCount]); ']);

proj=evalin('base',['var_temp_CBR{' num2str(mcbr) '}.getModel.project( temp_aux );']);
handles.plot.X=proj.plotT2Q('X','K','no');
evalin('base','clear temp_aux');

ins='';
for i = 1:length(evalin('base',['unique(var_temp_CBR{' num2str(mcbr) '}.getCaseBase.getClass);'])) %per cada classe
    ins=strcat(ins,['  ''class ' num2str(i) ' - Case Base'' '] );
    if i ~= length(evalin('base',['unique(var_temp_CBR{' num2str(mcbr) '}.getCaseBase.getClass);']))
        ins=strcat(ins,',');
    end
end
eval(['legend(' ins ',''Q Limit'',''T^2 Limit'',''Model Elements'', ''Selected Test Case'',''Location'',[0 0 100 100]);'])
%legend('clase 1 - Base Casos','clase 2 - Base Casos', 'clase 3 - Base Casos','Limit de Q','Limit de T^2','Elements del Model','Limit de Q','Limit de T^2', 'Cas de Test seleccionat','Vei seleccionat')
set(handles.popupmenu5,'Value',1)
guidata(hObject, handles);

function pushbutton1_Callback(~, ~, ~)
Menu_Load_Dades();

function popupmenu3_Callback(hObject, eventdata, handles)
 popupmenu1_Callback(hObject, eventdata, handles)%es on fa tot
function popupmenu4_Callback(hObject, eventdata, handles)
popupmenu1_Callback(hObject, eventdata, handles)%es on fa tot

function pushbutton2_Callback(~, ~, handles)
nom = genvarname( get(handles.edit7,'String'));
mcbr=get(handles.popupmenu1,'Value');% numero de partici CBR
evalin('base',[nom '= var_temp_CBR{' num2str(mcbr) '};'])
Update_Caller

function listbox1_Callback(hObject, ~, handles)
%recuperem el CBR
mcbr=get(handles.popupmenu1,'Value');
mcbr=['var_temp_CBR{' num2str(mcbr) '}'];%el CBR

%recuperem les dades
if get(handles.popupmenu3,'Value') == 1
    %es el del Cross validation
    mdades=get(handles.popupmenu1,'Value');
    mdades=['var_temp_Test(' num2str(mdades) ')'];%DATA
else
    %el que ens hagin indicat
    variable=get(handles.popupmenu4,'String');
    mdades=variable{get(handles.popupmenu4,'Value')};
    
end

if ~isempty(get(handles.listbox1,'String'))
    %han seleccionat un lot i existeix per tant el recuperem per fer els
    %plots corresponents
    
    [dad,clase,ref]=evalin('base',[ mdades '.getBatch(' num2str(get(handles.listbox1,'value')) ');' ]);
    aux=evalin('base',[mdades '.copy();']);
    
    %Els parametres del CBr estan inicialitzats segur - venim de fer un Cross
    
    aux.deleteBatch(1:aux.getBatchCount());
    aux.addBatch(dad,clase,ref);
    %global var_temp_CBR;
    assignin('base', 'temp_aux',aux);
    [vei, Test_set ]=evalin('base',[mcbr '.retrieve( temp_aux )']);
    [dades , class, noms] = evalin('base',[mcbr '.getCase( [' num2str(vei') '] )']);
    
    set(handles.listbox2,'String',noms);
    set(handles.listbox2,'Value',1);
    
    set(handles.edit3,'String', Test_set.getClass());
    set(handles.edit2,'String', Test_set.getQ());
    set(handles.edit1,'String', Test_set.getT2());
    
    aux=Test_set.getP();
    aux=aux(get(handles.listbox1,'Value'),:);
    aux=char2cell(num2str(aux))';
    
    set(handles.listbox3,'String', aux);
    set(handles.listbox3,'Value',1);
    
    %Actualitzem el plot
    mcb = get(handles.popupmenu1,'Value');
    if get(handles.popupmenu5,'Value') == 1
        if(isfield(handles,'plot'))
            %Com que tenim els handles del plot podem eliminar nomes el que
            %calgui!
            hold on
            
            %eliminem la part del plot que canvia!
            delete(handles.plot.X(handles.plot.X~=0));
            handles.plot=rmfield(handles.plot,'X');
          
            if(isfield(handles.plot,'O'))
                delete(handles.plot.O(handles.plot.O~=0));
                handles.plot=rmfield(handles.plot,'O');
            end
            
            %recuperem l'element seleccionat i el projectem!
            evalin('base',['temp_aux=' mdades '.copy;']);
            evalin('base',['temp_aux.deleteBatch([1:' num2str(get(handles.listbox1,'Value')-1) ' ' num2str(get(handles.listbox1,'Value')+1) ':temp_aux.getBatchCount]); ']);
            proj=evalin('base',['var_temp_CBR{' num2str(mcb) '}.getModel.project( temp_aux );']);
            
            %fem el plot corresponent per mostrar-lo a l'usuari!
            handles.plot.X=proj.plotT2Q('X','K','no');
            hold off
            evalin('base','clear temp_aux');
        else
            %no podem fer la optimitzaci perque no tenim els handles!
            
            axes(handles.axes1);
            cla;
            if isfield(handles, 'plot')
                handles=rmfield(handles,'plot');
            end
            axis auto;
            hold on
            %Cas de test selecccionat
            
            handles.plot.C_B=evalin('base',['var_temp_CBR{' num2str(mcb) '}.getCaseBase.plotT2Q(''.'');']);
            handles.plot.Mod=evalin('base',['var_temp_CBR{' num2str(mcb) '}.getModel.plotT2Q(''O'',[],''no'');']);
            
            %[dades class nom]=evalin('base',['var_temp_Test(' num2str(mcbr) ').getBatch(' num2str(get(handles.listbox1,'Value')) ');']);
            
            % evalin('base',['temp_aux=var_temp_Test(' num2str(mcb) ').copy;']);
            evalin('base',['temp_aux=' mdades '.copy;']);
            evalin('base',['temp_aux.deleteBatch([1:' num2str(get(handles.listbox1,'Value')-1) ' ' num2str(get(handles.listbox1,'Value')+1) ':temp_aux.getBatchCount]); ']);
            
            proj=evalin('base',['var_temp_CBR{' num2str(mcb) '}.getModel.project( temp_aux );']);
           handles.plot.X= proj.plotT2Q('X','K','no');
            hold off
            evalin('base','clear temp_aux');
            
        end
    end
    %dades i plot lot vei!
    [dad,clase,ref]=evalin('base',[ mdades '.getBatch(' num2str(get(handles.listbox1,'value')) ');' ]);
    aux=evalin('base',[mdades '.copy();']);
    
    %VK i DC estan inicialitzats venim de fer un cross
    
    aux.deleteBatch(1:aux.getBatchCount());
    aux.addBatch(dad,clase,ref);
    
    %[dades , ~, class noms]=eval([mcbr '.retrieve( aux  )']);
    %[dades , class, noms] = eval([mcbr '.getCase( ' vei ' )']);
    aux.deleteBatch(1:aux.getBatchCount());
    sel=get(handles.listbox2,'Value');
    if not(isempty(sel))
        
        aux.addBatch(dades(:,:,sel),class(sel),noms(sel));
            assignin('base', 'temp_aux',aux);
        [~, Test_set ]=evalin('base',[mcbr '.retrieve( temp_aux )']);
        
        set(handles.edit6,'String', Test_set.getClass());
        set(handles.edit5,'String', Test_set.getQ());
        set(handles.edit4,'String', Test_set.getT2());
        
        aux=Test_set.getT();
        %  aux=aux(get(handles.listbox2,'Value'),:);
        aux=char2cell(num2str(aux))';
        
        set(handles.listbox4,'String', aux);
        set(handles.listbox4,'Value',1);
        if get(handles.popupmenu5,'Value') == 1
            %plots %veins
            hold on
            handles.plot.O=Test_set.plotT2Q('O','K','no');
            hold off
        end
    end
    
    switch get(handles.popupmenu5,'Value')
        case 1
            ins='';
            for i = 1:length(evalin('base',['unique(var_temp_CBR{' num2str(mcb) '}.getCaseBase.getClass);'])) %per cada classe
                ins=strcat(ins,['  ''class ' num2str(i) ' - Case Base '' '] );
                if i ~= length(evalin('base',['unique(var_temp_CBR{' num2str(mcb) '}.getCaseBase.getClass);']))
                    ins=strcat(ins,',');
                end
            end
            eval(['legend(' ins ',''Q Limit'',''T^2 Limit'',''Model Elements'', ''Selected Test Case'',''Selected Neighbour'',''Location'',[0.15 0.1 0.01 0.01 ]);'])
        case 2
            axes(handles.axes1);
            cla;
            if isfield(handles, 'plot')
                handles=rmfield(handles,'plot');
            end
            axis auto;
            a=evalin('base',['var_temp_CBR{' num2str(mcb) '}.getCaseBase.copy']);
            a.deleteBatch(1:a.getBatchCount)
            a.addBatch(dad,clase,ref)
            a.addBatch(dades(:,:,get(handles.listbox2,'value')),class(get(handles.listbox2,'value')),noms(get(handles.listbox2,'value')))
            a.plotQContribution(:)
            legend('Test Batch','Neighbour Batch','Q Contribution Limit','Location',[0.15 0.1 0.01 0.01 ]);
        case 3
            axes(handles.axes1);
            cla;
            if isfield(handles, 'plot')
                handles=rmfield(handles,'plot');
            end
            axis auto;
            a=evalin('base',['var_temp_CBR{' num2str(mcb) '}.getCaseBase.copy']);
            a.deleteBatch(1:a.getBatchCount)
            a.addBatch(dad,clase,ref)
            a.addBatch(dades(:,:,get(handles.listbox2,'value')),class(get(handles.listbox2,'value')),noms(get(handles.listbox2,'value')))
            a.plotT2Contribution(:)
            legend('Test Batch','Neighbour Batch','T^2 Contribution Limit','Location',[0.15 0.1 0.01 0.01 ]);
        otherwise
    end
end
guidata(hObject, handles);

function listbox2_Callback(hObject, ~, handles)
%recuperem les dades
if get(handles.popupmenu3,'Value') == 1
    %es el del Cross validation
    mdades=get(handles.popupmenu1,'Value');
    mdades=['var_temp_Test(' num2str(mdades) ')'];%DATA
else
    %el que ens hagin indicat
    variable=get(handles.popupmenu4,'String');
    mdades=variable{get(handles.popupmenu4,'Value')};
    
end

if ~isempty(get(handles.listbox1,'String'))
    
    %Actualitzem el plot
    mcb = get(handles.popupmenu1,'Value');
    if get(handles.popupmenu5,'Value') == 1
        %recuperem el CBR
        if(isfield(handles,'plot'))
            %Com que tenim els handles del plot podem eliminar nomes el que
            %calgui!
            hold on
            
            %eliminem la part del plot que canvia!
            delete(handles.plot.X((handles.plot.X~=0)));
            handles.plot=rmfield(handles.plot,'X');
            if(isfield(handles.plot,'O'))
                delete(handles.plot.O(handles.plot.O~=0));
                handles.plot=rmfield(handles.plot,'O');
            end
            
            evalin('base',['temp_aux=' mdades '.copy;']);
            evalin('base',['temp_aux.deleteBatch([1:' num2str(get(handles.listbox1,'Value')-1) ' ' num2str(get(handles.listbox1,'Value')+1) ':temp_aux.getBatchCount]); ']);
            
            proj=evalin('base',['var_temp_CBR{' num2str(mcb) '}.getModel.project( temp_aux );']);
            handles.plot.X=proj.plotT2Q('X','K','no');
            hold off
            evalin('base','clear temp_aux');
            
        else
            
            
            axes(handles.axes1);
            cla;
            if isfield(handles, 'plot') 
                handles=rmfield(handles,'plot');
            end
            axis auto;
            hold on
            %Cas de test selecccionat
            
            handles.plot.C_B=evalin('base',['var_temp_CBR{' num2str(mcb) '}.getCaseBase.plotT2Q(''.'');']);
            handles.plot.Mod=evalin('base',['var_temp_CBR{' num2str(mcb) '}.getModel.plotT2Q(''O'',[],''no'');']);
            
            %[dades class nom]=evalin('base',['var_temp_Test(' num2str(mcbr) ').getBatch(' num2str(get(handles.listbox1,'Value')) ');']);
            
            % evalin('base',['temp_aux=var_temp_Test(' num2str(mcb) ').copy;']);
            evalin('base',['temp_aux=' mdades '.copy;']);
            evalin('base',['temp_aux.deleteBatch([1:' num2str(get(handles.listbox1,'Value')-1) ' ' num2str(get(handles.listbox1,'Value')+1) ':temp_aux.getBatchCount]); ']);
            
            proj=evalin('base',['var_temp_CBR{' num2str(mcb) '}.getModel.project( temp_aux );']);
            handles.plot.X=proj.plotT2Q('X','K','no');
            hold off
            evalin('base','clear temp_aux');
        end
    end
    mcbr=get(handles.popupmenu1,'Value');
    mcbr=['var_temp_CBR{' num2str(mcbr) '}'];%el CBR
    
    
    [dad,clase,ref]=evalin('base',[ mdades '.getBatch(' num2str(get(handles.listbox1,'value')) ');' ]);
    aux=evalin('base',[mdades '.copy();']);
    
    %VK i DC estan inicialitzats venim de fer un cross
    
    aux.deleteBatch(1:aux.getBatchCount());
    aux.addBatch(dad,clase,ref);
    %global  var_temp_CBR;
    %[vei , ~, class noms]=eval([mcbr '.retrieve( aux  )']);
        assignin('base', 'temp_aux',aux);
    [vei, ~ ]=evalin('base',[mcbr '.retrieve( temp_aux  )']);
    [dades , class, noms] = evalin('base',[mcbr '.getCase( [' num2str(vei') '] )']);
    
    aux.deleteBatch(1:aux.getBatchCount());
    sel=get(handles.listbox2,'Value');
    if not(isempty(sel))
        
        aux.addBatch(dades(:,:,sel),class(sel),noms(sel));
        [~, Test_set ]=evalin('base',[mcbr '.retrieve( temp_aux )']);
        
        set(handles.edit6,'String', Test_set.getClass());
        set(handles.edit5,'String', Test_set.getQ());
        set(handles.edit4,'String', Test_set.getT2());
        
        aux=Test_set.getT();
        % aux=aux(get(handles.listbox2,'Value'),:);
        aux=char2cell(num2str(aux))';
        
        set(handles.listbox4,'String', aux);
        set(handles.listbox4,'Value',1);
        if get(handles.popupmenu5,'Value') == 1
            %plot vei selec
            hold on
            handles.plot.O=Test_set.plotT2Q('O','K','no');
            hold off
        end
        
    end
    
    switch get(handles.popupmenu5,'Value')
        case 1
            ins='';
            for i = 1:length(evalin('base',['unique(var_temp_CBR{' num2str(mcb) '}.getCaseBase.getClass);'])) %per cada classe
                ins=strcat(ins,['  ''class ' num2str(i) ' - Case Base'' '] );
                if i ~= length(evalin('base',['unique(var_temp_CBR{' num2str(mcb) '}.getCaseBase.getClass);']))
                    ins=strcat(ins,',');
                end
            end
            eval(['legend(' ins ',''Q Limit'',''T^2 Limit'',''Model Elements'', ''Selected Test Case'',''Selected Neighbour'',''Location'', [0.15 0.1 0.01 0.01 ] );'])
        case 2
            axes(handles.axes1);
            cla;
            if isfield(handles, 'plot')
                handles=rmfield(handles,'plot');
            end
            axis auto;
            a=evalin('base',['var_temp_CBR{' num2str(mcb) '}.getCaseBase.copy']);
            a.deleteBatch(1:a.getBatchCount)
            a.addBatch(dad,clase,ref)
            a.addBatch(dades(:,:,get(handles.listbox2,'value')),class(get(handles.listbox2,'value')),noms(get(handles.listbox2,'value')))
            a.plotQContribution(:)
            legend('Test Batch','Neighbour Batch','Q Contribution Limit','Location',[0.15 0.1 0.01 0.01 ]);
        case 3
            axes(handles.axes1);
            cla;
            if isfield(handles, 'plot')
                handles=rmfield(handles,'plot');
            end
            axis auto;
            a=evalin('base',['var_temp_CBR{' num2str(mcb) '}.getCaseBase.copy']);
            a.deleteBatch(1:a.getBatchCount)
            a.addBatch(dad,clase,ref)
            a.addBatch(dades(:,:,get(handles.listbox2,'value')),class(get(handles.listbox2,'value')),noms(get(handles.listbox2,'value')))
            a.plotT2Contribution(:)
            legend('Test Batch','Neighbour Batch','T^2 Contribution Limit','Location',[0.15 0.1 0.01 0.01 ]);
        otherwise
    end
end
guidata(hObject, handles);

function listbox1_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function listbox2_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function Update(hObject, ~, handles) 
handles.output = hObject;
handles=menu(handles);
%actualitzar llistes ??
guidata(hObject, handles);

%% inutils
function listbox3_Callback(~, ~, ~)
function listbox3_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function listbox4_Callback(~, ~, ~)
function listbox4_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function popupmenu1_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function popupmenu3_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function popupmenu4_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edit1_Callback(~, ~, ~)
function edit1_CreateFcn(hObject, ~,~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edit2_Callback(~, ~, ~)
function edit2_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edit3_Callback(~, ~, ~)
function edit3_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edit4_Callback(~, ~, ~)
function edit4_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edit5_Callback(~, ~, ~)
function edit5_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edit6_Callback(~, ~, ~)
function edit6_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edit7_Callback(~, ~, ~)
function edit7_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function varargout = Menu_Veure_Veins_2_OutputFcn(~, ~, handles) 
varargout{1} = handles.output;


function figure1_CloseRequestFcn(hObject, ~, ~)
evalin('base','clear var_temp_CBR;')
evalin('base','clear var_temp_Test;')
evalin('base','clear temp_aux;')
delete(hObject);


function popupmenu5_Callback(hObject, eventdata, handles)
if(get(handles.popupmenu5,'Value')==2 || get(handles.popupmenu5,'Value')==3 )
    set(handles.pushbutton3,'Visible','on')
else
    set(handles.pushbutton3,'Visible','off')
end

if(get(handles.popupmenu5,'Value')==4) % Signatures Q
    %recuperem les dades
    if get(handles.popupmenu3,'Value') == 1
        axes(handles.axes1);
        cla;
        if isfield(handles, 'plot')
            handles=rmfield(handles,'plot');
        end
        hold on
        %es el del Cross validation
        mdades=get(handles.popupmenu1,'Value');
        mdades=['var_temp_CBR{' num2str(mdades) '}.getCaseBase.plotQSignatures();'];%DATA
        evalin('base',mdades);
        legend(get(legend,'String'),'Location',[0.15 0.1 0.01 0.01 ]);
        hold off
    else
        axes(handles.axes1);
        cla;
        if isfield(handles, 'plot')
            handles=rmfield(handles,'plot');
        end
        hold on
        %el que ens hagin indicat
        variable=get(handles.popupmenu1,'String');
        
               
        mdades=variable{get(handles.popupmenu1,'Value')};
        
        if strcmp(mdades(1:min(end,9)), 'Division ')
            mdades = ['temp_CBR{' mdades(10:end) '}'];
        end
        mdades=[ mdades '.getCaseBase.plotQSignatures();'];%DATA
        evalin('base',mdades);        
        legend(get(legend,'String'),'Location',[0.15 0.1 0.01 0.01 ]);
        hold off
    end
    colormap('JET');
end

if(get(handles.popupmenu5,'Value')==5) % Signatures T^2
    %recuperem les dades
    if get(handles.popupmenu3,'Value') == 1
        axes(handles.axes1);
        cla;
        if isfield(handles, 'plot') 
            handles=rmfield(handles,'plot');
        end
        hold on
        %es el del Cross validation
        mdades=get(handles.popupmenu1,'Value');
        mdades=['var_temp_CBR{' num2str(mdades) '}.getCaseBase.plotT2Signatures();'];%DATA
        evalin('base',mdades);
        legend(get(legend,'String'),'Location',[0.15 0.1 0.01 0.01 ]);
        hold off
    else
        axes(handles.axes1);
        cla;
        if isfield(handles, 'plot')
            handles=rmfield(handles,'plot');
        end
        hold on
        %el que ens hagin indicat
        variable=get(handles.popupmenu1,'String');
        mdades=variable{get(handles.popupmenu1,'Value')};
        
        if strcmp(mdades(1:min(end,9)), 'Division ')
            mdades = ['temp_CBR{' mdades(10:end) '}'];
        end
        
        mdades=[mdades '.getCaseBase.plotT2Signatures();'];%DATA
        evalin('base',mdades);
        legend(get(legend,'String'),'Location',[0.15 0.1 0.01 0.01 ]);
        hold off
    end
    colormap('JET');
end
guidata(hObject, handles);
listbox2_Callback(hObject, eventdata, handles)

function popupmenu5_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function pushbutton3_Callback(~, ~, handles)
aux=get(handles.axes1, 'children');
if length(aux) >= 3
    set(gca, 'children',aux([1:length(aux)-2 length(aux) length(aux)-1])');
end
drawnow
