function obj = PLS2PCA( struct ,vars , temps)
% Funci per convertir una estructura de dades de la PLSToolbox en un
% objecte PCA. La Pls toolbox per defecte no guarda les dades originals del
% proces, per tant perque aquest metode funcini corrctament caldra que
% avans de guardar l'estructura amb la PLS Toolbox forem que guardi totes
% les dades possibles. Tot i aix no sempre es pot aconseguir fer la
% converssi ja que totes les configuracins possibles a PCa no tenen
% equivalents a la PLS toolbox ni totes les de la PLS toolbox tenen
% equivalents a PCA.
%
% Parametres d'entrada
%
%      struct - Una estructura de dades de PLS Toolbox, Cal forar que
%               guardi totes les dades possibles, si no no es pot fer la
%               converssi!
%      
%      vars - El nombre de variables que te el nostre proces (la toolbox no
%             ho guarda) 
%
%      temps - el nombre d'instants de temps que te el nostre procs (la
%              tolbox no ho guarda) 
%
% Parametres de sortida
%
%      obj - Si la conversi s possible, objecte PCA equivalent a
%            l'estructura struct
%
%

%creem un objecte DATA on hi anirem posan totes les dades i posteriorment
%crearem el model
dad = DATA();

%comprobem si l'objecte struct te les dades que necessitemper fer la
%conversi, en cas contrari mostrarem error a l'usuari
if isempty(struct.detail.data{1}) || isempty(struct.detail.data{1}.data)
    error('Has de guardar l''objecte PLS forant guardar totes les dades');
end

%Com a nom de les dades posem el camp autor
dad.setName(struct.author);

%Calculem el nombre de lots que tenim
lots =size(struct.detail.data{1}.data,1);

%la toolbox guarda les dades en BW i nosatlresen 3D necessitem saber les
%dimencions originals per poder desfer l'unfolding amb la funcio serdataBW
dad.setRawDataBW(struct.detail.data{1}.data,vars,temps,lots);

%afegim les classes
dad.setClass(struct.detail.class{1,1});

%creem l'objecte PCA amb configuracins per defecte
obj = PCA(dad);

%si la PLS toolbox tenia una configuraci convertivle l'apliquem, si no
%deixem la configuraci per defecte.
if strcmp(struct.detail.preprocessing{1,1}.description,'Autoscale')
    obj.setPCSelectionMethod(1);
end
if strcmp(struct.detail.preprocessing{1,1}.description,'Grupscale')
    obj.setPCSelectionMethod(2);
end
end

