function varargout = Pantalla_Principal(varargin)
%Aquesta es la Pantalla inicial de l'aplicacio. Des d'aqui es pot accedir a 
%qualsevol de les altres pantalles directe o indirectament.
%
%Aquesta finestra te 2 funcionalitats basiques.
%      -Es el punt de partida de l'aplicacio.
%      -Permetre a l'usuari gestionar els objectes en memoria.
%
%Parametres d'entrada:
%
%       no s'utilitzen parametres d'entrada en aquesta finestra
%
%Parametres de sortida:
%
%       no s'utilitzen parametres de sortida en aquesta finestra
%
%
%Exemples:
%
%des de consola noms cal invocar la funcio Pantalla Principal per obrir la
%finestra.
%Pantalla_Principal()

%Autogenerat - inicialitza tots els callbacks i parametres de la finesta
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Pantalla_Principal_OpeningFcn, ...
                   'gui_OutputFcn',  @Pantalla_Principal_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

function Pantalla_Principal_OpeningFcn(hObject, ~, handles, varargin)
%funci que s'invoca en crear la finestra a varargin ens arriven el
%possibles parametres extres d'invocaci de Pantalla principal. No els
%utilitzarem per res. hObject i handles els modificarem.

handles.output = hObject;
handles=menu(handles);%incrustem el menu
guidata(hObject, handles); %guardem els canvis

%passem a posar la imatge de exit i la de l'udg amb els seus calbacks
%cal recuperar la ruta del fitxer pot no ser la del path actual
ruta = mfilename('fullpath');
ruta = ruta(1:end-18);%treiem el nom de la funci 'Pantalla_Principal'
%obrim els fitxers on tenim les imatges
iExit = imread([ruta 'Imatges' filesep 'logoexit.jpg']);
iUniversitat = imread([ruta 'Imatges' filesep 'udg.jpg']);

%ens posicionem als eixos on bolem mostrar i mostrem la imatge afegint-li
%el callback perque obrin la pagina web corresponent

%eXiT
axes(handles.axes2);
image(iExit,'ButtonDownFcn','web(''http://exit.udg.edu//'', ''-browser'')');
axis off;

%UdG
axes(handles.axes1);
image(iUniversitat,'ButtonDownFcn','web(''http://www.udg.edu//'', ''-browser'')');
axis off;



%busquem PCA , DATA i CBR 
x=evalin('base','whos();');
list=[];
for i=1:length(x)
    if ((strcmp(x(i).class,'DATA') ~=0) || (strcmp(x(i).class,'PCA') ~=0) || (strcmp(x(i).class,'CBR') ~=0) )
            list=[list; {x(i).name()}];
    end
end
if isempty(list)
    list={'Workspace is empty'};
end
set(handles.listbox1,'String',list);
set(handles.listbox1,'Value',1);

%Update per a Updatecaller
function Update(hObject, ~, handles) 
%Aquesta s la funci que ens invocara de manera automatica la funcio
%update_caller quan calgui actualitzar la interficie perque s'ha
%creat/destruit un objecte.
%En el cas de la pantalla principal nomes caldr actualitzar el men i la
%llista d'objectes del object manager.

%Actualitzem el menu
handles.output = hObject;
handles=menu(handles);

%busquem objectes
x=evalin('base','whos();');
list=[];
for i=1:length(x)
    if ((strcmp(x(i).class,'DATA') ~=0) || (strcmp(x(i).class,'PCA') ~=0) || (strcmp(x(i).class,'CBR') ~=0) )
            list=[list; {x(i).name()}];
    end
end
if isempty(list)
    list={'Workspace is empty'};
end
set(handles.listbox1,'String',list);%posem els noms que hem trovat a la llista
set(handles.listbox1,'Value',1);%select del primer per evitar errors (tenir seleccionat element inexistent)

%guardem els canvis en els handles
guidata(hObject, handles);

%Llista object manager
function listbox1_Callback(hObject, ~, handles)
%funcio que s'activara cada cop que l'usuari cliki la llista amb noms, aqui
%posarem el tipus d'objecte al display corresponent. Tambe controlarem si
%l'usuari fa dobleclick per obrir els mens d'edici d'objectes. Per fer-ho
%ens servirem de variables persistents.

%posem el text
nom=get(handles.listbox1,'String');
nom=nom{get(handles.listbox1,'Value')};

if strcmp(nom,'Workspace is empty')
    %si no hi ha variables posem a buit el camp on es mostra la classe de
    %l'element
    set(handles.text2,'String','')
else
    %hi ha com a minim una variable i l'han seleccionat procedim a
    %recuperar-ne el nom i la classe per mostrar-la
    
    x=evalin('base',['whos(''' nom ''')' ]);%recuperem totes les dades de la variable
    set(handles.text2,'String',x.class) %posem la classe al camp de la GUI corresponent
    
    %Quan l'usuari fa un dobleclick sobre el nom d'un objecte obrirem el
    %menu d'edicio corresponent a cada classe d'objectes
    
    %creem una variable persistent per saber si hi ha una instancia
    %d'aquesta funci corrent en memoria
    persistent chk
    
    if isempty(chk)
        %no te valor la variable persistent -> Es el primer cop
        
        chk = 1;%inicialitzem la variable persistent
        pause(0.2); %fem un petit delay esperat que es faci el dobleclick o no
        if chk == 1
            %single click
            chk = []; %eliminem la variable persistent
        end
    else
        %doble click
        chk = [];%eliminem la variable persistent
        
        %No bolem ser interromputs mentre creem finestres podrien passar
        %coses rares
        set(hObject,'interruptible','off')
        
        %invoquem la pantalla de modificaci de l'objecte
        switch x.class
            case 'DATA'
                Menu_Editar_Dades2(nom);
                
            case 'PCA'
                Menu_Configura_PCA(nom);
                
            case 'CBR'
                Menu_CBR(nom);
                
            otherwise
                %no hauria d'arrivar mai aqui pero per si de cas!
                errordlg('Unrecognised object Class!','Error');
        end
        
        %tornem a permetre les interrupcions
        set(hObject,'interruptible','on')
    end
    
end

%Delete
function pushbutton1_Callback(~, ~, handles)
%callback del boto Delete. Aix ens indica que l'usuari vol eliminar la
%variable que hi ha seleccionada en aquest moment

%recuperem el nom
nom=get(handles.listbox1,'String');
nom=nom{get(handles.listbox1,'Value')};

if strcmp(nom,'Workspace is empty')
    %no hi ha variables
    set(handles.text2,'String','');
else
    %hi ha variable seleccionada
    
    %muntem el nom de la variable
    
    evalin('base',['clear ' nom]);%eliminem la variable del base
    %set(handles.text2,'String','');%no cal updatecaller ja ho fara!
    Update_Caller();%fem que actualitzi tot
    
end

%Update
function pushbutton3_Callback(~, ~, ~)
%Callback del boto Update List. La llista no esta actualitzada per tant en
%comptes de fer-ho manualment Cridem updateCaller aixi actualitzem totes
%les pantalles.
Update_Caller();


%--------------------- INUTILS --------------------------------------------
%Callbacks necessaries pero que no utilitzem, sn autogenerades
function varargout = Pantalla_Principal_OutputFcn(~, ~, handles) 
varargout{1} = handles.output;
function listbox1_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
