function Plot_Confusion_Matrix(classp,classreal,maxclasses,te,M)
%Funci per dibuixar grficament les matrius de confusi que crea la funci
%compute_extended_confusion_matrix, necessitarem a ms a ms l'objecte
%dades on tenim guardats els lots corresponents per poder mostrar els
%popupmenus.
%
%Parametres d'entrada
%
%       Classp - La classe predita, ha de ser un cell, dins el cell hi ha
%                d'haver tants lists com matrius es bulguin representar
%
%                Exemple:
%                
%                {[1 1 1]} Per representar una matriu
%                {[1 1 1] [1 2 1] [1 2 3]} per representar 3 matrius
%
%
%       Classreal - La classe real, ha de ser un cell dins el cell hi ha
%                   d'haver tants lists com matrius es bulguin representar
%
%                Exemple:
%                
%                {[1 1 1]} Per representar una matriu
%                {[1 1 1] [1 2 1] [1 2 3]} per representar 3 matrius
%
%
%       maxclasses - numero maxim de classes
%
%       te - (opcional) Objecte DATA amb els objectes de la classe de test,
%             ha de ser una llista contenin 1 o tants objectes data com
%             matrius es bulguin representar  
%
%       M - (opcional) Si es te el resultat de cridar
%            compute_extended_confusion_matrix es pot evitar fe la crida de
%            nou i tenir major eficiencia. 
%
% Sortida
%
% No te parametres de sortida, realitza la visualitzaci de les matrius de
% confusi en plots, en cas d'indicar, te es mostrara la correspondencia de
% lots en clicar al nombre, en cas d'indicar ms d'una matriu es mostrara
% la matriu global.
%
%
%Exemples
% on a s un objecte dades
%
% Plot_Confusion_Matrix({a.getClass},{a.getClass},max(a.getClass), [a]);
%
% Plot_Confusion_Matrix({a.getClass a.getClass},{a.getClass a.getClass},max(a.getClass), [a a])
%
% Plot_Confusion_Matrix({[1 2 1]},{[1 1 1]},3)

for i=1:length(classp)
    %Calculem la Matriu de confuci
    if nargin < 5
        M{i}=compute_extended_confusion_matrix(classp{i},classreal{i},maxclasses);
    end
    %La passem a 'a' per posar-la be
    a=M{i};
    a=a(length(a):-1:1,:);
    
    %fem una figura i en recuperem el datacursormode per poder editar
    %els datatips.
    if(length(M) ==1)
        %ens criden externament
        
        dcm_obj = datacursormode(gcf);
        
        hold on
        imagesc((ones([size(a) 3])));
        
        %posem el titol
        %title('Confusion Matrix', 'FontSize',20)
        
        %treiem els noms dels eixos perque ja els posarem manualment
        axis off
        
    else
        %ens crida el Cross-validation
        
        dcm_obj = datacursormode(figure);
        hold on
        imagesc((ones([size(a) 3])));
        
        %posem el titol
        title(['Confusion Matrix  /  Division ' num2str(i)],'FontSize',20)
        
        %treiem els noms dels eixos perque ja els posarem manualment
        axis off
    end

    
    if nargin >= 4%si ens passen dades posarem datatip
        %asignem el nom de le funci que es cridara amb el datatip
        set(dcm_obj,'UpdateFcn',@myfunction)
    end
    
    %posem els noms del eixos
    text(0.2,size(M{i},1)/2,' Real Class','Rotation',90,'FontSize',15);
    text(size(M{i},1)/2,0.2,' Predicted Class','FontSize',15);
    
    for ii=1: size(M{i},1)
        %Posem els noms del eixos i dibuixem les linies
        text(0.3,size(M{i},1)-ii+1,num2str(ii));%text eix Y
        text(ii,0.3,num2str(ii));%text eix X
        line([ii+0.5 ; ii+0.5],[length(a)+0.5 ; 0.5],'color', 'K' );
        line([length(a)+0.5 ; 0.5],[ii+0.5 ; ii+0.5],'color', 'K' );
        
        for j=1: size(M{i},1)
            %posem el numero vermell a la posicio que toca
            text(ii,j,num2str(a(j,ii)),'Color','r','fontSize',30);
            
            if nargin >= 4
                %Per si ens passen un objecte DATA posem els lots al
                %datatip
                
                %generem els datatip
                if a(j,ii) == 0
                    %si no hi ha lots que fallen posem empty
                    numl(j,ii) = {'empty'};
                    acu{j,ii,i} = 'empty';
                    

                        if isempty(te(i).getBatchLabel)
                            refl(j,ii) = {'not defined!'};
                        else
                            refl(j,ii) = {'empty'};
                        end

                    
                else
                    %hi ha lots, hem de recuperar els noms i les posicions per
                    %passar-los al datatip
                    % index=(classp{i} == ii).*(te(i).getClass == (maxclasses-j+1));% modificaci no necessari utilitzar l'acces a l'objecte ho tenim  a classrereal
                    index=(classp{i} == ii).*(classreal{i} == (maxclasses-j+1));
                    
                    aux=1:te(i).getBatchCount();
                    
                    numl(j,ii) = {num2str(aux(index==1))};
                    
                    if isempty(te(i).getBatchLabel)
                        refl(j,ii) = {'not defined!'};
                    else
                        refl(j,ii) = {cell2str(strcat(te(i).getBatchLabel(index==1),{' '}))};
                        acu{j,ii,i} = cell2str(strcat(te(i).getBatchLabel(index==1) , {' '}));
                    end
                end
            end
        end
        
    end
    
    %posem les linies dels eixos
    line([0.5 ; 0.5],[length(a)+0.5 ; 0.5],'color', 'K' );
    line([length(a)+0.5 ; 0.5],[0.5 ; 0.5],'color', 'K' );
    
    if nargin >= 4 %si ens passen dades posem un datatip
        %Asignem els datatips
        set(get(dcm_obj,'figure'),'userdata',{ a' numl' refl'});
    end
    
    hold off
end

if length(M) > 1%nomes dibuixem la acumulada si hi ha mes d'una partici
    %fem el grafic Global
    dcm_obj = datacursormode(figure);
    %calculem la matriu acumulada
    a=M{1};
    for i=2:length(M)
        a=a+M{i};
    end
    
    %posem be els numeros
    a=a(length(a):-1:1,:);
    
    %Comenem a dibuixar
    hold on
    imagesc((ones([size(a) 3])));
    
    %posem el titol
    title('Total Confusion Matrix','FontSize',20)
    %treiem els numeros dels eixos
    axis off
    %posem els noms de els eixos
    text(0.2,size(M{i},1)/2,' Real Class','Rotation',90,'FontSize',15);
    text(size(M{i},1)/2,0.2,' Predicted Class','FontSize',15);
    %pintem la matriu
    for ii=1: size(a,1)
        %test als eixos
        text(0.3,size(a,1)-ii+1,num2str(ii));
        text(ii,0.3,num2str(ii));
        %linies de separaci
        line([ii+0.5 ; ii+0.5],[length(a)+0.5 ; 0.5],'color', 'K' );
        line([length(a)+0.5 ; 0.5],[ii+0.5 ; ii+0.5],'color', 'K' );
        for j=1: size(a,1)
            %numero en vermell
            text(ii,j,num2str(a(j,ii)),'Color','r','fontSize',30);
        end
    end
    %linia de separaci
    line([0.5 ; 0.5],[length(a)+0.5 ; 0.5],'color', 'K' );
    line([length(a)+0.5 ; 0.5],[0.5 ; 0.5],'color', 'K' );
    
    if nargin >= 4 %si ens passen l'objecte dades posem datatip
        %Posem el datatip
        set(dcm_obj,'UpdateFcn',@myfunction)
        set(get(dcm_obj,'figure'),'userdata',{ a' [] acu});
    end
    
    hold off
end
end

function output_txt = myfunction(~,event_obj)
%funci que s'encarrega d'escriure el datatip utilitzant les dades
%guardades a event_obj
try
    dad=get(get(0,'CurrentFigure'),'userdata');
    p=get(event_obj,'position');
    if isempty(dad{2})
        output_txt = {['Total batch number: ' num2str(dad{1}(p(1),p(2)))] '' 'batch reference:' dad{3}{p(2),p(1),:}  };
        
    else
        output_txt = {['Total batch number: ' num2str(dad{1}(p(1),p(2)))] '' 'batch number:' dad{2}{p(1),p(2)} '' 'batch reference:' dad{3}{p(1),p(2)}  };
    end
catch
    output_txt ={''};
end
end