function cell2csv(fileName, cellArray, separator)
% Guarda un cell a un fitxer en format CSV.
%
%Parametres d'entrada:
%
%       fileName - String amb ruta i noom del fitxer a on es vol guardar el
%                  cell
%
%
%       cellArray - Un cell amb strings, logicals o valors numerics que
%                   volem guardar al fitzer en format CSV. el cell ha de
%                   tenir maxim 2 dimencions la primera els valors es
%                   separaran amb el caracter indicat a separator i a la
%                   segona amb \r\n
%
%       separator - Caracter que s'utilitzara per separar els elements de
%                   la primera dimenci


%separador de decimal que utilitzem
decimal = '.';


%% Write file
datei = fopen(fileName, 'a');

for z=1:size(cellArray, 1)
    for s=1:size(cellArray, 2)
        
        var = eval('cellArray{z,s}');
        % If zero, then empty cell
        if size(var, 1) == 0
            var = '';
        end
        % If numeric -> String
        if isnumeric(var)
            var = num2str(var);
            % Conversion of decimal separator (4 Europe & South America)
            % http://commons.wikimedia.org/wiki/File:DecimalSeparator.svg
            if decimal ~= '.'
                var = strrep(var, '.', decimal);
            end
        end
        % If logical -> 'true' or 'false'
        if islogical(var)
            if var == 1
                var = 'TRUE';
            else
                var = 'FALSE';
            end
        end
        
        if strcmp(var,'\r\n')
            fprintf(datei,'\r\n');
        else
            
            % OUTPUT value
            fprintf(datei, '%s', var);
            
            % OUTPUT separator
            if s ~= size(cellArray, 2)
                fprintf(datei, separator);
            end
        end
    end
    if z ~= size(cellArray, 1) % prevent a empty line at EOF
        % OUTPUT newline
        fprintf(datei, '\r\n');
    end
end
% Closing file
fclose(datei);
% END



