function out = degradatcolors(vars, temps)
        %Genera un degradat de vars colors comenant pel color pur i
        %acavant a practicament blanc. El nombre de colors que composen el
        %degradat l'indiquem amb la variable temps.
        %
        %Parametres d'entrada:
        % 
        %       vars - double que indica el nombre de colors que volem
        %
        %       temps - double indica el nombre de colors que volem que
        %               tingui el degradat de cada un dels colors indicats
        %               a vars 
        %
        %Parametres de sortida:
        %
        %        out - matriu de doubles, te 3 columnes components (R,G,B)
        %              dels colors i a les (vars * temps) files hi tenim
        %              posat el decradat de cada un dels colors. 
        %
        %              [1 - temps] color 1 
        %              [temps+1 a temps*2] color 2
        %              ...
        %              ...
        %
        
        %Construim els vectors amb els valors de saturacio i color
        h = 1:vars;
        s = 1:temps;
        
        %reservem l'espai
        out = ones(vars*temps,3); 

        %Construim els colors en HSV amb v=1
        %escollim var colors vase al maxim d'allunyats possible entre ells
        out(:,1) = reshape(repmat(h,temps,1),1,vars*temps)./vars;

        %posem el degradat variant la saturaci de color
        out(:,2) = repmat(s,1,vars) ./ (temps*1.5) +0.3;%no deixem arrivar a blanc perque es distingeixi sempre entre les variables

        %V esta inicialitzat a 1 no cal tocar res ms

        %transformem de HSV a RGB
        out = hsv2rgb(out);
end