function handles=menu(handles)
%Funci per incrustar el menu a la finestra de la qual ens passen el
%handles. o b si ja hi ha el men actualitzar-lo segons els objectes que
%tinguem presents al workspace.
%
%handles - Es l'estructura on matlab guarda totes les dades relatives a una
%interfice previament creada. un cop incrustat el menu retornarem el
%handles perque pugui ser actualitzat.
%

if not(isfield(handles,'hemexecutat')) %comprobem si ja ha estat creat
    handles.hemexecutat=1;
    
    %%Pestanya d'accions basiques
    f0 = uimenu(gcf,'Label','Main');
    uimenu(f0,'Label','Main Window','Callback','Pantalla_Principal');
    uimenu(f0,'Label','Close','Callback','close all');
    handles.menu.f0=f0;
    
    
    %%Pestanya principal DATA
    f1 = uimenu(gcf,'Label','DATA');
    handles.menu.f1=f1;
    %subpestanya Crear DATA
    f11 = uimenu(f1,'Label','Create');
    uimenu(f11,'Label','Load DATA from file','Callback','uiwait(Menu_Load_Dades);');
    uimenu(f11,'Label','Load DATA from workspace','Callback','uiwait(Menu_Crear_Dades);');
    
    handles.menu.f11=f11;
    %subpestanya Guardar DATA
    f111 = uimenu(f1,'Label','Save');
    uimenu(f111,'Label','Save DATA','Callback','Menu_Save_Dades');
   
    handles.menu.f111=f111;
    %subpestanya modificar DATA
    f12 = uimenu(f1,'Label','Edit');
    uimenu(f12,'Label','Edit an object','Callback','Menu_Editar_Dades2');
    uimenu(f12,'Label','Move Batch between objects','Callback','Menu_Canvia_Lots');
    handles.menu.f12=f12;
    %subpestanya Visualitzar DATA
   % Ja no el menu Canvia lots fa el mateix
   % f13 = uimenu(f1,'Label','Visualitzar');
   % uimenu(f13,'Label','Plots','Callback','Plots_Dades');
   % handles.menu.f13=f13;
    
    
    %%Pestanya principal PCA
    f2 = uimenu(gcf,'Label','PCA');
    handles.menu.f2=f2;
    %subpestanya Crear
    f21 = uimenu(f2,'Label','Create');   
    uimenu(f21,'Label','New Model PCA','Callback','uiwait(Menu_Crea_Model_PCA);');
    uimenu(f21,'Label','New Projection','Callback','uiwait(Menu_Projecta_Dades_PCA);');
    handles.menu.f21=f21;
    
    f24 = uimenu(f2,'Label','Save'); 
    uimenu(f24,'Label','Save PCA','Callback','Menu_Save_PCA');
    
    handles.menu.f24=f24;
    %Canviem ara nomes tenim la finestra PCA
    %subpestanya modificar
    %f22 = uimenu(f2,'Label','Edit');
    %uimenu(f22,'Label','Configure','Callback','Menu_Configura_PCA');
    %handles.menu.f22=f22;
    %subpestanya Visualitzar
    %f23 = uimenu(f2,'Label','Plots');
    %uimenu(f23,'Label','Plots','Callback','Plots_PCA');
    
    f23 = uimenu(f2,'Label','PCA','Callback','Menu_PCA');
    handles.menu.f23=f23;
    
    %%Pestanya principal CBR
    f3 = uimenu(gcf,'Label','CBR');
    handles.menu.f3=f3;
    %subpestanyes de CBR
    f31=uimenu(f3,'Label','Create new CBR','Callback','uiwait(Menu_Crea_CBR);');    
    f33 = uimenu(f3,'Label','Save'); 
    f32=uimenu(f3,'Label','CBR','Callback','Menu_CBR');
    
    uimenu(f33,'Label','Save CBR','Callback','Menu_Save_CBR');
    
    handles.menu.f31=f31;
    handles.menu.f32=f32;
    handles.menu.f33=f33;
    
    f7 = uimenu(gcf,'Label','Segment');
    f71=uimenu(f7,'Label','Segment','Callback','Menu_Talla');
    handles.menu.f71=f71;
    %%Pestanya principal Cross
    f4 = uimenu(gcf,'Label','Cross - Validation');
    uimenu(f4,'Label','Cross - Validation','Callback','Menu_Cross');
    handles.menu.f4=f4;
    
    f5 = uimenu(gcf,'Label','Commands');
    uimenu(f5,'Label','Command Window','Callback','Command_window');
    uimenu(f5,'Label','Command Examples','Callback','Menu_Exemples');
    
    ruta = mfilename('fullpath');
    ruta = ruta(1:end-4);%treiem el nom de la funci 'Pantalla_Principal'

    uimenu(f5,'Label','Command User Manual','Callback',['open(''' ruta 'Ajuda' filesep 'help.pdf' ''')']); %ajuda per les comandes
    handles.menu.f5=f5;
    %% Ajuda sobre l'aplicaci
    f6=uimenu(gcf,'Label','Help');
    uimenu(f6,'Label','User Interface Manual','Callback',['open(''' ruta 'Ajuda' filesep 'help2.pdf' ''')']);
    uimenu(f6,'Label','eXiT','Callback','web(''http://exit.udg.edu/'', ''-browser'')');
    handles.menu.f6=f6;

end

%habilitem i deshabilitem les pestanyes que no calen actualment

%mirem si hi ha algun DATA al workspace
x=evalin('base','whos();');
trobatDATA = false;
trobatPCA = false;
trobatCBR = false;
final = isempty(x);
i=1;
lx = length(x)+1;

while(~trobatDATA || ~trobatPCA || ~trobatCBR) && ~ final
    if strcmp(x(i).class,'DATA')
        trobatDATA = true;
    end
    
    if strcmp(x(i).class,'PCA')
        trobatPCA = true;
    end
    
    if strcmp(x(i).class,'CBR')
        trobatCBR = true;
    end
    i=i+1;
    final =  i == lx;
end


% si no tenim cap objecte DATA no te sentit ni modificar ni visualitzar
% ...

set(handles.menu.f71,'enable','off');

if ~trobatDATA
    set(handles.menu.f111,'enable','off');
    set(handles.menu.f12,'enable','off');
%    set(handles.menu.f13,'enable','off');
else
    set( handles.menu.f111,'enable','on');
    set(handles.menu.f12,'enable','on');
  %  set(handles.menu.f13,'enable','on');
  set(handles.menu.f71,'enable','on');
end


% si no tenim cap objecte PCA no te sentit ni modificar ni visualitzar
if ~trobatPCA
    % set(handles.menu.f22,'enable','off');
    set(handles.menu.f23,'enable','off');
    set(handles.menu.f24,'enable','off');
else
    % set(handles.menu.f22,'enable','on');
    set(handles.menu.f23,'enable','on');
    set(handles.menu.f24,'enable','on');
    
    set(handles.menu.f71,'enable','on');
end


% si no tenim cap objecte CBR no te sentit ni modificar ni visualitzar
if ~trobatCBR
    set(handles.menu.f32,'enable','off');
    set(handles.menu.f33,'enable','off');
else
    set(handles.menu.f32,'enable','on');
    set(handles.menu.f33,'enable','on');
    set(handles.menu.f71,'enable','on');
end


% %La funcio que criden els menus es la 
% function Update(hObject, eventdata, handles) 
% handles.output = hObject;
% handles=menu(handles);%per actualitzar el menu
% guidata(hObject, handles);



%     %uimenu(f11,'Label','Load DATA','Callback','Menu_Load_Dades');
%     
%     %quan es tenqui la finestra load dades invocarem el metode update de
%     %totes les finestres obertes el codi que ho fa es:
%     %uiwait(Menu_Load_Dades); %espera a que hagi acavat la finestra
%     %figHandles =findall(0,''Type'',''figure''); %busquem totes les finestres
%     %for i=1:length(figHandles)
%     %   eval([handle(figHandles(i)).name'(''Update'',gcf,[],guidata(gcf))'] );  %invoquem el metode update de cada una de les finestres!
%     %end
% 
%     %uimenu(f11,'Label','Load DATA','Callback','uiwait(Menu_Load_Dades);figHandles = findall(0,''Type'',''figure'');for i=1:length(figHandles); eval([handle(figHandles(i)).name ''(''''Update'''',gcf,[],guidata(gcf))'' ]);end');

%     %uimenu(f21,'Label','Crear Model PCA','Callback','Menu_Crea_Model_PCA');
%     %uimenu(f21,'Label','Projecta','Callback','Menu_Projecta_Dades_PCA');
%     
%     uimenu(f21,'Label','Crear Model PCA','Callback','uiwait(Menu_Crea_Model_PCA);figHandles = findall(0,''Type'',''figure'');for i=1:length(figHandles); eval([handle(figHandles(i)).name ''(''''Update'''',gcf,[],guidata(gcf))'' ]);end');
%     uimenu(f21,'Label','Projecta','Callback','uiwait(Menu_Projecta_Dades_PCA);figHandles = findall(0,''Type'',''figure'');for i=1:length(figHandles); eval([handle(figHandles(i)).name ''(''''Update'''',gcf,[],guidata(gcf))'' ]);end');
%  

%     %f31=uimenu(f3,'Label','Crear CBR','Callback','Menu_Crea_CBR');
%     f31=uimenu(f3,'Label','Crear CBR','Callback','uiwait(Menu_Crea_CBR);figHandles = findall(0,''Type'',''figure'');for i=1:length(figHandles); eval([handle(figHandles(i)).name ''(''''Update'''',gcf,[],guidata(gcf))'' ]);end');
